/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _Tree = __webpack_require__(1);

	var _Tree2 = _interopRequireDefault(_Tree);

	var _Select = __webpack_require__(100);

	var _Select2 = _interopRequireDefault(_Select);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	module.exports = { Tree: _Tree2.default, Select: _Select2.default };

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _assign = __webpack_require__(2);

	var _assign2 = _interopRequireDefault(_assign);

	var _defineProperty2 = __webpack_require__(39);

	var _defineProperty3 = _interopRequireDefault(_defineProperty2);

	var _extends4 = __webpack_require__(43);

	var _extends5 = _interopRequireDefault(_extends4);

	var _objectWithoutProperties2 = __webpack_require__(44);

	var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

	var _getPrototypeOf = __webpack_require__(45);

	var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

	var _classCallCheck2 = __webpack_require__(50);

	var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

	var _createClass2 = __webpack_require__(51);

	var _createClass3 = _interopRequireDefault(_createClass2);

	var _possibleConstructorReturn2 = __webpack_require__(52);

	var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

	var _inherits2 = __webpack_require__(87);

	var _inherits3 = _interopRequireDefault(_inherits2);

	var _react = __webpack_require__(95);

	var _react2 = _interopRequireDefault(_react);

	var _classnames = __webpack_require__(96);

	var _classnames2 = _interopRequireDefault(_classnames);

	var _TreeNode = __webpack_require__(97);

	var _TreeNode2 = _interopRequireDefault(_TreeNode);

	var _dataTree = __webpack_require__(99);

	var _dataTree2 = _interopRequireDefault(_dataTree);

	var _util = __webpack_require__(98);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var Tree = function (_React$Component) {
	  (0, _inherits3.default)(Tree, _React$Component);

	  function Tree(props) {
	    (0, _classCallCheck3.default)(this, Tree);

	    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Tree).call(this, props));

	    ['onExpand', 'onSelect', 'onCheck'].forEach(function (m) {
	      _this[m] = _this[m].bind(_this);
	    });

	    /**
	     * 初始化状态标识
	     * 数据一般都是异步加载，在生成Component时，由于props.data为空，导致props.defaultChecked等值无效
	     * 这里折中处理下，加一个状态标识，以便在props.data第一次不为空的情况下，取值于defaultChecked，而不是取值于checked
	     */
	    _this.initial = true;

	    _this.state = {
	      treeDatas: props.data,
	      /**
	       * 用来存储当前树选中的checkbox状态
	       * @type {Object} key为node.value，value值，1为选中，2为半选中
	       */
	      checkedMaps: _this.getCheckedMaps(props),
	      selectedMaps: _this.getSelectedMaps(props),
	      expandedMaps: _this.getExpandedMaps(props, props.data)
	    };

	    _this.initial = !(props.data && props.data.length > 0);
	    /**
	     * 存储当前树所有节点的对象，方便后面通过node.value可以获取
	     * @type {Object}
	     */
	    _this.nodeMaps = {};
	    /**
	     * 这里存储的是选中的节点对象，与state.selectedMaps不同
	     * 用于回调props.onChange时使用
	     */
	    _this.selectedNodes = [];
	    _this.checkedNodes = [];
	    /**
	     * 把数据导入到DataTree中，方便后面搜索用
	     */
	    _this.dataTree = new _dataTree2.default().import(props.data.slice());

	    return _this;
	  }

	  (0, _createClass3.default)(Tree, [{
	    key: 'componentWillReceiveProps',
	    value: function componentWillReceiveProps(nextProps) {
	      var _props = this.props;
	      var data = _props.data;
	      var dataMode = _props.dataMode;
	      var checked = _props.checked;
	      var selected = _props.selected;
	      var expanded = _props.expanded;
	      var expandAll = _props.expandAll;
	      var _state = this.state;
	      var treeDatas = _state.treeDatas;
	      var checkedMaps = _state.checkedMaps;
	      var selectedMaps = _state.selectedMaps;
	      var expandedMaps = _state.expandedMaps;
	      // 数据改变时，重设map数据，避免存在脏数据

	      if (data !== nextProps.data || dataMode !== nextProps.dataMode) {
	        this.nodeMaps = {};
	        this.state.selectedMaps = {};
	        this.state.checkedMaps = {};
	        this.state.expandedMaps = {};

	        treeDatas = nextProps.data;
	        this.dataTree.import(data.slice());
	      }

	      if (checked !== nextProps.checked) {
	        checkedMaps = this.getCheckedMaps(nextProps);
	      }

	      if (selected !== nextProps.selected) {
	        selectedMaps = this.getSelectedMaps(nextProps);
	      }

	      if (expanded !== nextProps.expanded || expandAll !== nextProps.expandAll) {
	        expandedMaps = this.getExpandedMaps(nextProps, nextProps.data);
	      }

	      this.initial = !(nextProps.data && nextProps.data.length > 0);

	      this.setState({ treeDatas: treeDatas, checkedMaps: checkedMaps, selectedMaps: selectedMaps, expandedMaps: expandedMaps });
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      var _wrapperCls,
	          _this2 = this;

	      var _props2 = this.props;
	      var data = _props2.data;
	      var animate = _props2.animate;
	      var bordered = _props2.bordered;
	      var className = _props2.className;
	      var style = _props2.style;
	      var width = _props2.width;
	      var height = _props2.height;
	      var prefixCls = _props2.prefixCls;
	      var children = _props2.children;
	      var otherProps = (0, _objectWithoutProperties3.default)(_props2, ['data', 'animate', 'bordered', 'className', 'style', 'width', 'height', 'prefixCls', 'children']);
	      var treeDatas = this.state.treeDatas;

	      var wrapperPrefixCls = prefixCls + '-panel';
	      var wrapperStyle = (0, _extends5.default)({}, style || {}, { width: width, height: height });
	      var wrapperCls = (_wrapperCls = {}, (0, _defineProperty3.default)(_wrapperCls, wrapperPrefixCls, true), (0, _defineProperty3.default)(_wrapperCls, wrapperPrefixCls + '-bordered', bordered), _wrapperCls);
	      var treeCls = (0, _defineProperty3.default)({}, prefixCls, true);

	      return _react2.default.createElement(
	        'div',
	        { unselectable: true, style: wrapperStyle, className: (0, _classnames2.default)(className, wrapperCls) },
	        _react2.default.createElement(
	          'ul',
	          (0, _extends5.default)({}, otherProps, { className: (0, _classnames2.default)(treeCls) }),
	          treeDatas.map(function (item, index) {
	            return _this2.generateTreeNode(item, index);
	          })
	        )
	      );
	    }
	  }, {
	    key: 'getCheckedMaps',
	    value: function getCheckedMaps(props) {
	      var data = props.data;
	      var multiple = props.multiple;
	      var commbox = props.commbox;
	      var checked = props.checked;
	      var defaultChecked = props.defaultChecked;
	      // 不是初始化时，只取checked的值，否则优先取值于checked

	      var values = (this.initial ? checked || defaultChecked : checked) || [];
	      var map = {};

	      if (commbox) {
	        // 多选情况下，其父、子节点的级联选中状态不作处理，当它传递的值是“有效的”
	        // 这和在外面维护checked这个值是一样的，它通过props传递过来，以更新commbox的选中状态
	        multiple ? values.forEach(function (item) {
	          return map[item] = _util.CHECKBOX_CHECKED;
	        }) : map[values[0]] = _util.CHECKBOX_CHECKED;
	      }

	      // 如果values为空的情况，应当清空原有数据
	      if (values.length == 0) {
	        this.checkedNodes = [];
	      }

	      return map;
	    }
	  }, {
	    key: 'getSelectedMaps',
	    value: function getSelectedMaps(props) {
	      var multiple = props.multiple;
	      var selected = props.selected;
	      var defaultSelected = props.defaultSelected;
	      // 不是初始化时，只取selected的值，否则优先取值于selected

	      var values = (this.initial ? selected || defaultSelected : selected) || [];
	      var map = {};

	      // 单选模式下，只选取第一个值
	      multiple ? values.forEach(function (item) {
	        return map[item] = true;
	      }) : map[values[0]] = true;

	      // 如果values为空的情况，应当清空原有数据
	      if (values.length == 0) {
	        this.selectedNodes = [];
	      }

	      return map;
	    }
	  }, {
	    key: 'getExpandedMaps',
	    value: function getExpandedMaps(props, data) {
	      var _this3 = this;

	      var expandAll = props.expandAll;
	      var expanded = props.expanded;
	      var defaultExpanded = props.defaultExpanded;

	      var map = {};

	      if (expandAll) {
	        (data || []).forEach(function (item) {
	          map[item.id] = true;
	          var children = item.children;
	          if (children && children.length > 0) {
	            // 递归所有子节点，并合并到map中
	            var _map = _this3.getExpandedMaps(props, children);
	            (0, _assign2.default)(map, _map);
	          }
	        });
	      } else {
	        // 不是初始化时，只取expanded的值，否则优先取值于expanded
	        var values = (this.initial ? expanded || defaultExpanded : expanded) || [];
	        values.forEach(function (item) {
	          return map[item] = true;
	        });
	      }

	      return map;
	    }

	    /**
	     * 渲染树节点
	     * @param  {Object} nodeData  节点数据
	     * @param  {Number} index  索引值
	     * @param  {Object} parentData 父节点数据
	     * @param  {Number} prePath  节点路径，根节点的路径为0，它的子节点为0-0, 0-1, ...
	     * @return {TreeNode}      节点对象
	     */

	  }, {
	    key: 'generateTreeNode',
	    value: function generateTreeNode(nodeData, index, parentData) {
	      var _this4 = this;

	      var prePath = arguments.length <= 3 || arguments[3] === undefined ? 0 : arguments[3];

	      if (!nodeData.id || !nodeData.text) {
	        throw 'Error. 节点属性 {id} {text} 不能为空。';
	      }

	      var _state2 = this.state;
	      var expandedMaps = _state2.expandedMaps;
	      var selectedMaps = _state2.selectedMaps;
	      var checkedMaps = _state2.checkedMaps;
	      var _props3 = this.props;
	      var multiple = _props3.multiple;
	      var commbox = _props3.commbox;
	      var animate = _props3.animate;
	      var value = nodeData.id;
	      var text = nodeData.text;
	      var children = nodeData.children;

	      var path = nodeData.path || prePath + '-' + index;
	      var selected = selectedMaps[value] || false;
	      var checked = checkedMaps[value] || _util.CHECKBOX_UNCHECKED;
	      var expanded = expandedMaps[value] || false;
	      var leaf = !children || children.length <= 0;
	      var childNodes = void 0;

	      var nodeProps = {
	        ref: 'node-' + path,
	        key: path,
	        data: nodeData,
	        childData: children,
	        parentData: parentData,
	        value: value,
	        text: text,
	        path: path,
	        selected: selected,
	        checked: checked,
	        expanded: expanded,
	        leaf: leaf,
	        multiple: multiple,
	        commbox: commbox,
	        onExpand: this.onExpand,
	        onSelect: this.onSelect,
	        onCheck: this.onCheck
	      };

	      // 生成已展开的子节点
	      if (expanded && children && children.length) {
	        childNodes = _react2.default.createElement(
	          'ul',
	          null,
	          children.map(function (item, index) {
	            return _this4.generateTreeNode(item, index, nodeData, path);
	          })
	        );
	      }

	      // 节点的ref为`node-${path}`的方式，为方便通过ID获取节点对象，这里把node缓存起来
	      return this.nodeMaps[value] = _react2.default.createElement(
	        _TreeNode2.default,
	        nodeProps,
	        childNodes
	      );
	    }

	    /**
	     * 节点展开、收缩事件，从TreeNode回调过来
	     * @param  {Boolean} expanded 标识当前是展开还是收缩动作
	     * @param  {TreeNode} node   节点对象        
	     */

	  }, {
	    key: 'onExpand',
	    value: function onExpand(expanded, node) {
	      // console.log('Tree.onExpand', expanded, node)
	      var expandedMaps = this.state.expandedMaps;
	      // 如果外面没有传递expanded值过来，即调用setState()更新UI，否则就让外面维护这个状态

	      if (!('expanded' in this.props)) {
	        this.setState({
	          expandedMaps: (0, _extends5.default)({}, expandedMaps, (0, _defineProperty3.default)({}, node.props.value, expanded))
	        });
	      }
	      this.props.onExpand(expanded, node);
	    }
	  }, {
	    key: 'onSelect',
	    value: function onSelect(selected, node) {
	      // 此处需要合并selected 。
	      var selectedMaps = this.state.selectedMaps;
	      var _props4 = this.props;
	      var multiple = _props4.multiple;
	      var commbox = _props4.commbox;
	      var onSelect = _props4.onSelect;
	      var _node$props = node.props;
	      var value = _node$props.value;
	      var data = _node$props.data;


	      if (onSelect(selected, value, data, node) === false) {
	        return;
	      }

	      // 如果外面没有传递selected值过来，即调用setState()更新UI，否则就让外面维护这个状态
	      if (!('selected' in this.props)) {
	        // 多选且没有commbox时，才允许选择多个，否则它的选中以commbox为主
	        if (multiple && !commbox) {
	          this.setState({
	            selectedMaps: (0, _extends5.default)({}, selectedMaps, (0, _defineProperty3.default)({}, value, selected))
	          });
	        } else {
	          this.setState({
	            selectedMaps: (0, _defineProperty3.default)({}, value, selected)
	          });
	        }
	      }

	      // 多选，且有commbox时，不触发其onChange事件，以commbox的check为主
	      // 单选，且有commbox时，该onSelect不会被触发，这里不需处理
	      if (!(multiple && commbox)) {
	        this.setSelectedNodes(selected, data, 'selectedNodes');
	        this.fireChange({ selected: selected, value: value, data: data, node: node, selectedNodes: this.selectedNodes });
	      }
	    }
	  }, {
	    key: 'onCheck',
	    value: function onCheck(checked, node) {
	      // console.log('Tree.onCheck', checked, node)
	      var _props5 = this.props;
	      var multiple = _props5.multiple;
	      var commbox = _props5.commbox;
	      var _node$props2 = node.props;
	      var value = _node$props2.value;
	      var data = _node$props2.data;

	      var checkState = (0, _util.checkStateToBoolean)(checked);

	      if (this.props.onCheck(checkState, value, data, node) === false) {
	        return;
	      }

	      this.toggleCheckState(checked, data);

	      // 如果外面没有传递checked值过来，即调用setState()更新UI，否则就让外面维护这个状态
	      if (!('checked' in this.props)) {
	        this.setState({
	          // 在遍历当前节点的父、子节点，并改变它的check state时，并没有调用setState()更新，这里统一处理
	          checkedMaps: this.state.checkedMaps,
	          // 单选情况下，把selected一起更新
	          selectedMaps: !multiple ? (0, _defineProperty3.default)({}, value, (0, _util.checkStateToBoolean)(checked)) : this.state.selectedMaps
	        });
	      }

	      this.fireChange({ selected: checkState, value: value, data: data, node: node, selectedNodes: this.checkedNodes });
	    }
	  }, {
	    key: 'setSelectedNodes',
	    value: function setSelectedNodes(selected, data, dataKey) {
	      var multiple = this.props.multiple;

	      if (multiple) {
	        if (selected) {
	          this[dataKey].push(data);
	        } else {
	          this[dataKey] = this[dataKey].filter(function (item) {
	            return item.id !== data.id;
	          });
	        }
	      } else {
	        this[dataKey] = [data];
	      }
	    }
	    // 此处有更改

	  }, {
	    key: 'fireChange',
	    value: function fireChange(info) {
	      var _this5 = this;

	      var _props6 = this.props;
	      var multiple = _props6.multiple;
	      var commbox = _props6.commbox;
	      var onChange = _props6.onChange;
	      var defaultChecked = _props6.defaultChecked;
	      var defaultSeleced = _props6.defaultSeleced;
	      var checked = _props6.checked;
	      var selected = info.selected;
	      var value = info.value;
	      var data = info.data;
	      var node = info.node;
	      var selectedNodes = info.selectedNodes;

	      var propsValues = defaultChecked || checked || defaultSeleced || this.props.selected;

	      if (multiple) {
	        (function () {
	          var values = [],
	              datas = [];
	          selectedNodes.forEach(function (data) {
	            values.push(data.id);
	            datas.push(data);
	          });
	          // 如果是选中的情形下
	          if (selected) {
	            propsValues.forEach(function (item) {
	              if (!_this5.contains(item, values)) {
	                values.push(item);
	                datas.push(_this5.getNodeById(value));
	              }
	            });
	          } else {
	            if (!commbox) {
	              values = [], datas = [];
	              // 找到所在位置
	              var index = _this5.indexOf(value, propsValues);

	              if (index > -1) {
	                propsValues.splice(index, 1);
	              }
	              propsValues.forEach(function (item) {
	                values.push(item);
	                datas.push(_this5.getNodeById(item));
	              });
	            }
	          }
	          onChange(values, datas, node);
	        })();
	      } else {
	        // 单项选择，在取消选中时，返回空
	        selected ? onChange([value], [data], node) : onChange(undefined, undefined, node);
	      }
	    }
	  }, {
	    key: 'toggleCheckState',
	    value: function toggleCheckState(checked, nodeData) {
	      var _props7 = this.props;
	      var multiple = _props7.multiple;
	      var checkStrictly = _props7.checkStrictly;

	      // 不是多选或开启多选严格模式时，选中哪个节点就仅仅选中哪个节点，不作关联操作

	      if (!multiple) {
	        // 单选
	        this.state.checkedMaps = (0, _defineProperty3.default)({}, nodeData.id, checked);
	      } else if (multiple && checkStrictly) {
	        // 多选，且开启了多选的严格模式
	        this.state.checkedMaps[nodeData.id] = checked;
	      } else {
	        // 级联多选

	        if (checked) {
	          // 子节点全设为checked
	          this.cascade(this.setNodeCheckState, nodeData, _util.CHECKBOX_CHECKED);
	          // 父节点全设为partial
	          this.bubble(this.setNodeCheckState, nodeData, _util.CHECKBOX_PARTIAL);
	        } else {
	          // 子节点全设为unchecked
	          this.cascade(this.setNodeCheckState, nodeData, _util.CHECKBOX_UNCHECKED);
	          // 父节点全设为partial
	          this.bubble(this.setNodeCheckState, nodeData, _util.CHECKBOX_PARTIAL);
	        }
	      }
	    }

	    /**
	     * 根据路径获取节点对象
	     * @param  {String} path 节点路径
	     * @return {Object}      返回搜索到的节点对象
	     */

	  }, {
	    key: 'findNode',
	    value: function findNode(path) {
	      return this.refs['node-' + path];
	    }

	    /**
	     * 根据当前节点路径，获取它的父节点路径
	     * @param  {String} path 节点路径
	     * @return {String}      返回搜索到的节点路径，如果当前节点为根节点，返回空字符
	     */

	  }, {
	    key: 'getParentPath',
	    value: function getParentPath(path) {
	      return path ? path.substring(0, path.lastIndexOf('-')) : '';
	    }
	  }, {
	    key: 'getParentNode',
	    value: function getParentNode(nodeData) {
	      var node = this.nodeMaps[nodeData.id] || { props: {} };
	      return this.findNode(this.getParentPath(node.props.path));
	    }

	    /**
	     * 设置节点的checkbox的选中状态
	     * @param {TreeNode} node       节点对象
	     * @param {Number} checkState   选中状态：0，1，2
	     */

	  }, {
	    key: 'setNodeCheckState',
	    value: function setNodeCheckState(nodeData, checkState) {
	      var _this6 = this;

	      // console.log('Tree.check: ', node.props.value, checkState)
	      var nodeValue = nodeData.id;
	      var checkedMaps = this.state.checkedMaps,
	          __checkState = checkState;

	      if (checkState === _util.CHECKBOX_PARTIAL) {
	        (function () {
	          // 重新计算该节点的checked值

	          var children = nodeData.children;
	          var sumChecked = 0,
	              sumPartial = 0;

	          children.forEach(function (child) {
	            // 这里需要取到TreeNode节点对象，以便获取它现在的选择状态
	            var node = _this6.nodeMaps[child.id];
	            // 节点的checkState在checkMaps中可能已发生变化，但UI还没更新，这里需要从checkedMaps中获取它最新的checkState
	            var childCheckState = checkedMaps[node.props.value] !== undefined ? checkedMaps[node.props.value] : node.props.checked;

	            if (childCheckState === _util.CHECKBOX_CHECKED) {
	              sumChecked++;
	            } else if (childCheckState === _util.CHECKBOX_PARTIAL) {
	              sumPartial++;
	            }
	          });

	          __checkState = children.length === sumChecked ? _util.CHECKBOX_CHECKED : sumChecked > 0 || sumPartial > 0 ? _util.CHECKBOX_PARTIAL : _util.CHECKBOX_UNCHECKED;
	        })();
	      }

	      this.setSelectedNodes((0, _util.checkStateToBoolean)(__checkState), nodeData, 'checkedNodes');
	      // 这里不使用setState()，避免多次更新UI，赋值完成后，将在onCheck()中统一更新
	      checkedMaps[nodeValue] = __checkState;
	    }

	    /**
	     * 冒泡(遍历所有父节点)
	     * @param  {Function} cb   [description]
	     * @param  {[type]}   nodeData [description]
	     * @param  {[type]}   checkState [description]
	     * @return {[type]}        [description]
	     */

	  }, {
	    key: 'bubble',
	    value: function bubble(cb, nodeData, checkState) {
	      var parentNode = this.getParentNode(nodeData);
	      while (parentNode) {
	        var parentData = parentNode.props.data;
	        if (cb.call(this, parentData, checkState) === false) {
	          break;
	        }
	        parentNode = this.getParentNode(parentData);
	      }
	    }
	    /**
	     * 瀑布(遍历所有子节点)
	     * @param  {Function} cb   [description]
	     * @param  {[type]}   nodeData [description]
	     * @param  {[type]}   checkState [description]
	     * @return {[type]}        [description]
	     */

	  }, {
	    key: 'cascade',
	    value: function cascade(cb, nodeData, checkState) {
	      var _this7 = this;

	      if (cb.call(this, nodeData, checkState) !== false) {
	        nodeData.children && nodeData.children.length && nodeData.children.forEach(function (child) {
	          _this7.cascade(cb, child, checkState);
	        });
	      }
	    }

	    /**
	     * 包含 contains 
	     * @return {[type]} [description]
	     */

	  }, {
	    key: 'contains',
	    value: function contains(id, container) {
	      var bool = false;
	      container.forEach(function (item) {
	        if (item === id) {
	          return bool = true;
	        }
	      });
	      return bool;
	    }
	  }, {
	    key: 'indexOf',
	    value: function indexOf(id, container) {
	      var i = -1;
	      container.forEach(function (item, key) {
	        if (item === id) {
	          return i = key;
	        }
	      });
	      return i;
	    }
	  }, {
	    key: 'getNodeById',
	    value: function getNodeById(id) {
	      var tree = this.dataTree;
	      var targetNode = null;
	      tree.traverseDFS(function (node) {
	        // 如果存在多各根节点的情形
	        if (node._depth == 1 && node._childNodes.length > 1) {
	          node._childNodes.forEach(function (nodeItem) {
	            if (nodeItem._data.id === id) {
	              return targetNode = nodeItem._data;
	            }
	          });
	        } else {
	          if (node._data.id === id) {
	            targetNode = node._data;
	          }
	        }
	      });
	      return targetNode;
	    }
	  }, {
	    key: 'getDirectParentNode',
	    value: function getDirectParentNode(id) {
	      var tree = this.dataTree;
	      var targetNode = null;
	      tree.traverseDFS(function (node) {
	        // 如果存在多各根节点的情形
	        if (node._depth == 1 && node._childNodes.length > 1) {
	          node._childNodes.forEach(function (nodeItem) {
	            nodeItem.getAncestry().forEach(function (item) {
	              item._data.children.forEach(function (child) {
	                if (child.id == id) {
	                  return targetNode = item._data;
	                }
	              });
	            });
	          });
	        } else {
	          node.getAncestry().forEach(function (item) {
	            item._data.children.forEach(function (child) {
	              if (child.id == id) {
	                return targetNode = item._data;
	              }
	            });
	          });
	        }
	      });
	      return targetNode;
	    }
	  }]);
	  return Tree;
	}(_react2.default.Component);

	Tree.propTypes = {
	  width: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
	  height: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
	  /**
	   * 树组件的data数据集
	   */
	  data: _react.PropTypes.array.isRequired,
	  /**
	   * 根节点
	   */
	  rootNode: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.element]),
	  /**
	   * 是否在展开、收缩节点时添加动画
	   */
	  animate: _react.PropTypes.bool,
	  /**
	   * 是否展开所有节点
	   */
	  expandAll: _react.PropTypes.bool,
	  /**
	   * 选中的节点
	   */
	  selected: _react.PropTypes.array,
	  /**
	   * 默认选中的节点，注意与selected的区别
	   * 当selected给了值后，在选中行时，Tree内部不会调用setState()更新UI，需要外面把更新后的selected传递过来
	   * 下面的checked, defaultChecked也是如此
	   */
	  defaultSelected: _react.PropTypes.array,
	  /**
	   * 选中的节点（指选中它的checkbox或radio，仅commbox=true时有效）
	   */
	  checked: _react.PropTypes.array,
	  /**
	   * 默认选中的节点
	   */
	  defaultChecked: _react.PropTypes.array,
	  /**
	   * 展开的节点
	   */
	  expanded: _react.PropTypes.array,
	  /**
	   * 默认展开的节点
	   */
	  defaultExpanded: _react.PropTypes.array,
	  /**
	   * 是否显示commbox
	   */
	  commbox: _react.PropTypes.bool,
	  /**
	   * 是否多选
	   * @type {[type]}
	   */
	  multiple: _react.PropTypes.bool,
	  /**
	   * 是否开启多选的严格模式，开启时，选中节点时，不会同时选中它的父节点或子节点
	   */
	  checkStrictly: _react.PropTypes.bool,
	  /**
	   * 是否显示border
	   */
	  bordered: _react.PropTypes.bool,
	  /**
	   * 展开、收缩节点时的回调事件
	   * @type {[function(isExpanded, node)]}
	   */
	  onExpand: _react.PropTypes.func,
	  /**
	   * 选中节点时的回调事件（在commbox=true时无效）
	   * @type {[function(isSelected, value, data, node)]}
	   */
	  onSelect: _react.PropTypes.func,
	  /**
	   * 选中commbox时的回调事件（仅commbox=true时有效）
	   * @type {[function(isChecked, value, data, node)]}
	   */
	  onCheck: _react.PropTypes.func,
	  /**
	   * 选中的节点发生变化时的回调事件
	   * @type {[function(value, data, node)]}
	   */
	  onChange: _react.PropTypes.func
	};

	Tree.defaultProps = {
	  prefixCls: 'rt-tree',
	  animate: true,
	  bordered: true,
	  useArrow: true,
	  onExpand: _util.noop,
	  onSelect: _util.noop,
	  onCheck: _util.noop,
	  onChange: _util.noop
	};

	Tree.elementType = 'Tree';

	exports.default = Tree;

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(3), __esModule: true };

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(4);
	module.exports = __webpack_require__(7).Object.assign;

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	// 19.1.3.1 Object.assign(target, source)
	var $export = __webpack_require__(5);

	$export($export.S + $export.F, 'Object', {assign: __webpack_require__(20)});

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	var global    = __webpack_require__(6)
	  , core      = __webpack_require__(7)
	  , ctx       = __webpack_require__(8)
	  , hide      = __webpack_require__(10)
	  , PROTOTYPE = 'prototype';

	var $export = function(type, name, source){
	  var IS_FORCED = type & $export.F
	    , IS_GLOBAL = type & $export.G
	    , IS_STATIC = type & $export.S
	    , IS_PROTO  = type & $export.P
	    , IS_BIND   = type & $export.B
	    , IS_WRAP   = type & $export.W
	    , exports   = IS_GLOBAL ? core : core[name] || (core[name] = {})
	    , expProto  = exports[PROTOTYPE]
	    , target    = IS_GLOBAL ? global : IS_STATIC ? global[name] : (global[name] || {})[PROTOTYPE]
	    , key, own, out;
	  if(IS_GLOBAL)source = name;
	  for(key in source){
	    // contains in native
	    own = !IS_FORCED && target && target[key] !== undefined;
	    if(own && key in exports)continue;
	    // export native or passed
	    out = own ? target[key] : source[key];
	    // prevent global pollution for namespaces
	    exports[key] = IS_GLOBAL && typeof target[key] != 'function' ? source[key]
	    // bind timers to global for call from export context
	    : IS_BIND && own ? ctx(out, global)
	    // wrap global constructors for prevent change them in library
	    : IS_WRAP && target[key] == out ? (function(C){
	      var F = function(a, b, c){
	        if(this instanceof C){
	          switch(arguments.length){
	            case 0: return new C;
	            case 1: return new C(a);
	            case 2: return new C(a, b);
	          } return new C(a, b, c);
	        } return C.apply(this, arguments);
	      };
	      F[PROTOTYPE] = C[PROTOTYPE];
	      return F;
	    // make static versions for prototype methods
	    })(out) : IS_PROTO && typeof out == 'function' ? ctx(Function.call, out) : out;
	    // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
	    if(IS_PROTO){
	      (exports.virtual || (exports.virtual = {}))[key] = out;
	      // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
	      if(type & $export.R && expProto && !expProto[key])hide(expProto, key, out);
	    }
	  }
	};
	// type bitmap
	$export.F = 1;   // forced
	$export.G = 2;   // global
	$export.S = 4;   // static
	$export.P = 8;   // proto
	$export.B = 16;  // bind
	$export.W = 32;  // wrap
	$export.U = 64;  // safe
	$export.R = 128; // real proto method for `library` 
	module.exports = $export;

/***/ },
/* 6 */
/***/ function(module, exports) {

	// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
	var global = module.exports = typeof window != 'undefined' && window.Math == Math
	  ? window : typeof self != 'undefined' && self.Math == Math ? self : Function('return this')();
	if(typeof __g == 'number')__g = global; // eslint-disable-line no-undef

/***/ },
/* 7 */
/***/ function(module, exports) {

	var core = module.exports = {version: '2.4.0'};
	if(typeof __e == 'number')__e = core; // eslint-disable-line no-undef

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	// optional / simple context binding
	var aFunction = __webpack_require__(9);
	module.exports = function(fn, that, length){
	  aFunction(fn);
	  if(that === undefined)return fn;
	  switch(length){
	    case 1: return function(a){
	      return fn.call(that, a);
	    };
	    case 2: return function(a, b){
	      return fn.call(that, a, b);
	    };
	    case 3: return function(a, b, c){
	      return fn.call(that, a, b, c);
	    };
	  }
	  return function(/* ...args */){
	    return fn.apply(that, arguments);
	  };
	};

/***/ },
/* 9 */
/***/ function(module, exports) {

	module.exports = function(it){
	  if(typeof it != 'function')throw TypeError(it + ' is not a function!');
	  return it;
	};

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	var dP         = __webpack_require__(11)
	  , createDesc = __webpack_require__(19);
	module.exports = __webpack_require__(15) ? function(object, key, value){
	  return dP.f(object, key, createDesc(1, value));
	} : function(object, key, value){
	  object[key] = value;
	  return object;
	};

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	var anObject       = __webpack_require__(12)
	  , IE8_DOM_DEFINE = __webpack_require__(14)
	  , toPrimitive    = __webpack_require__(18)
	  , dP             = Object.defineProperty;

	exports.f = __webpack_require__(15) ? Object.defineProperty : function defineProperty(O, P, Attributes){
	  anObject(O);
	  P = toPrimitive(P, true);
	  anObject(Attributes);
	  if(IE8_DOM_DEFINE)try {
	    return dP(O, P, Attributes);
	  } catch(e){ /* empty */ }
	  if('get' in Attributes || 'set' in Attributes)throw TypeError('Accessors not supported!');
	  if('value' in Attributes)O[P] = Attributes.value;
	  return O;
	};

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	var isObject = __webpack_require__(13);
	module.exports = function(it){
	  if(!isObject(it))throw TypeError(it + ' is not an object!');
	  return it;
	};

/***/ },
/* 13 */
/***/ function(module, exports) {

	module.exports = function(it){
	  return typeof it === 'object' ? it !== null : typeof it === 'function';
	};

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = !__webpack_require__(15) && !__webpack_require__(16)(function(){
	  return Object.defineProperty(__webpack_require__(17)('div'), 'a', {get: function(){ return 7; }}).a != 7;
	});

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	// Thank's IE8 for his funny defineProperty
	module.exports = !__webpack_require__(16)(function(){
	  return Object.defineProperty({}, 'a', {get: function(){ return 7; }}).a != 7;
	});

/***/ },
/* 16 */
/***/ function(module, exports) {

	module.exports = function(exec){
	  try {
	    return !!exec();
	  } catch(e){
	    return true;
	  }
	};

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	var isObject = __webpack_require__(13)
	  , document = __webpack_require__(6).document
	  // in old IE typeof document.createElement is 'object'
	  , is = isObject(document) && isObject(document.createElement);
	module.exports = function(it){
	  return is ? document.createElement(it) : {};
	};

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	// 7.1.1 ToPrimitive(input [, PreferredType])
	var isObject = __webpack_require__(13);
	// instead of the ES6 spec version, we didn't implement @@toPrimitive case
	// and the second argument - flag - preferred type is a string
	module.exports = function(it, S){
	  if(!isObject(it))return it;
	  var fn, val;
	  if(S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it)))return val;
	  if(typeof (fn = it.valueOf) == 'function' && !isObject(val = fn.call(it)))return val;
	  if(!S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it)))return val;
	  throw TypeError("Can't convert object to primitive value");
	};

/***/ },
/* 19 */
/***/ function(module, exports) {

	module.exports = function(bitmap, value){
	  return {
	    enumerable  : !(bitmap & 1),
	    configurable: !(bitmap & 2),
	    writable    : !(bitmap & 4),
	    value       : value
	  };
	};

/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	// 19.1.2.1 Object.assign(target, source, ...)
	var getKeys  = __webpack_require__(21)
	  , gOPS     = __webpack_require__(36)
	  , pIE      = __webpack_require__(37)
	  , toObject = __webpack_require__(38)
	  , IObject  = __webpack_require__(25)
	  , $assign  = Object.assign;

	// should work with symbols and should have deterministic property order (V8 bug)
	module.exports = !$assign || __webpack_require__(16)(function(){
	  var A = {}
	    , B = {}
	    , S = Symbol()
	    , K = 'abcdefghijklmnopqrst';
	  A[S] = 7;
	  K.split('').forEach(function(k){ B[k] = k; });
	  return $assign({}, A)[S] != 7 || Object.keys($assign({}, B)).join('') != K;
	}) ? function assign(target, source){ // eslint-disable-line no-unused-vars
	  var T     = toObject(target)
	    , aLen  = arguments.length
	    , index = 1
	    , getSymbols = gOPS.f
	    , isEnum     = pIE.f;
	  while(aLen > index){
	    var S      = IObject(arguments[index++])
	      , keys   = getSymbols ? getKeys(S).concat(getSymbols(S)) : getKeys(S)
	      , length = keys.length
	      , j      = 0
	      , key;
	    while(length > j)if(isEnum.call(S, key = keys[j++]))T[key] = S[key];
	  } return T;
	} : $assign;

/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	// 19.1.2.14 / 15.2.3.14 Object.keys(O)
	var $keys       = __webpack_require__(22)
	  , enumBugKeys = __webpack_require__(35);

	module.exports = Object.keys || function keys(O){
	  return $keys(O, enumBugKeys);
	};

/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	var has          = __webpack_require__(23)
	  , toIObject    = __webpack_require__(24)
	  , arrayIndexOf = __webpack_require__(28)(false)
	  , IE_PROTO     = __webpack_require__(32)('IE_PROTO');

	module.exports = function(object, names){
	  var O      = toIObject(object)
	    , i      = 0
	    , result = []
	    , key;
	  for(key in O)if(key != IE_PROTO)has(O, key) && result.push(key);
	  // Don't enum bug & hidden keys
	  while(names.length > i)if(has(O, key = names[i++])){
	    ~arrayIndexOf(result, key) || result.push(key);
	  }
	  return result;
	};

/***/ },
/* 23 */
/***/ function(module, exports) {

	var hasOwnProperty = {}.hasOwnProperty;
	module.exports = function(it, key){
	  return hasOwnProperty.call(it, key);
	};

/***/ },
/* 24 */
/***/ function(module, exports, __webpack_require__) {

	// to indexed object, toObject with fallback for non-array-like ES3 strings
	var IObject = __webpack_require__(25)
	  , defined = __webpack_require__(27);
	module.exports = function(it){
	  return IObject(defined(it));
	};

/***/ },
/* 25 */
/***/ function(module, exports, __webpack_require__) {

	// fallback for non-array-like ES3 and non-enumerable old V8 strings
	var cof = __webpack_require__(26);
	module.exports = Object('z').propertyIsEnumerable(0) ? Object : function(it){
	  return cof(it) == 'String' ? it.split('') : Object(it);
	};

/***/ },
/* 26 */
/***/ function(module, exports) {

	var toString = {}.toString;

	module.exports = function(it){
	  return toString.call(it).slice(8, -1);
	};

/***/ },
/* 27 */
/***/ function(module, exports) {

	// 7.2.1 RequireObjectCoercible(argument)
	module.exports = function(it){
	  if(it == undefined)throw TypeError("Can't call method on  " + it);
	  return it;
	};

/***/ },
/* 28 */
/***/ function(module, exports, __webpack_require__) {

	// false -> Array#indexOf
	// true  -> Array#includes
	var toIObject = __webpack_require__(24)
	  , toLength  = __webpack_require__(29)
	  , toIndex   = __webpack_require__(31);
	module.exports = function(IS_INCLUDES){
	  return function($this, el, fromIndex){
	    var O      = toIObject($this)
	      , length = toLength(O.length)
	      , index  = toIndex(fromIndex, length)
	      , value;
	    // Array#includes uses SameValueZero equality algorithm
	    if(IS_INCLUDES && el != el)while(length > index){
	      value = O[index++];
	      if(value != value)return true;
	    // Array#toIndex ignores holes, Array#includes - not
	    } else for(;length > index; index++)if(IS_INCLUDES || index in O){
	      if(O[index] === el)return IS_INCLUDES || index || 0;
	    } return !IS_INCLUDES && -1;
	  };
	};

/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	// 7.1.15 ToLength
	var toInteger = __webpack_require__(30)
	  , min       = Math.min;
	module.exports = function(it){
	  return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
	};

/***/ },
/* 30 */
/***/ function(module, exports) {

	// 7.1.4 ToInteger
	var ceil  = Math.ceil
	  , floor = Math.floor;
	module.exports = function(it){
	  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
	};

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	var toInteger = __webpack_require__(30)
	  , max       = Math.max
	  , min       = Math.min;
	module.exports = function(index, length){
	  index = toInteger(index);
	  return index < 0 ? max(index + length, 0) : min(index, length);
	};

/***/ },
/* 32 */
/***/ function(module, exports, __webpack_require__) {

	var shared = __webpack_require__(33)('keys')
	  , uid    = __webpack_require__(34);
	module.exports = function(key){
	  return shared[key] || (shared[key] = uid(key));
	};

/***/ },
/* 33 */
/***/ function(module, exports, __webpack_require__) {

	var global = __webpack_require__(6)
	  , SHARED = '__core-js_shared__'
	  , store  = global[SHARED] || (global[SHARED] = {});
	module.exports = function(key){
	  return store[key] || (store[key] = {});
	};

/***/ },
/* 34 */
/***/ function(module, exports) {

	var id = 0
	  , px = Math.random();
	module.exports = function(key){
	  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
	};

/***/ },
/* 35 */
/***/ function(module, exports) {

	// IE 8- don't enum bug keys
	module.exports = (
	  'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
	).split(',');

/***/ },
/* 36 */
/***/ function(module, exports) {

	exports.f = Object.getOwnPropertySymbols;

/***/ },
/* 37 */
/***/ function(module, exports) {

	exports.f = {}.propertyIsEnumerable;

/***/ },
/* 38 */
/***/ function(module, exports, __webpack_require__) {

	// 7.1.13 ToObject(argument)
	var defined = __webpack_require__(27);
	module.exports = function(it){
	  return Object(defined(it));
	};

/***/ },
/* 39 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	exports.__esModule = true;

	var _defineProperty = __webpack_require__(40);

	var _defineProperty2 = _interopRequireDefault(_defineProperty);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = function (obj, key, value) {
	  if (key in obj) {
	    (0, _defineProperty2.default)(obj, key, {
	      value: value,
	      enumerable: true,
	      configurable: true,
	      writable: true
	    });
	  } else {
	    obj[key] = value;
	  }

	  return obj;
	};

/***/ },
/* 40 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(41), __esModule: true };

/***/ },
/* 41 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(42);
	var $Object = __webpack_require__(7).Object;
	module.exports = function defineProperty(it, key, desc){
	  return $Object.defineProperty(it, key, desc);
	};

/***/ },
/* 42 */
/***/ function(module, exports, __webpack_require__) {

	var $export = __webpack_require__(5);
	// 19.1.2.4 / 15.2.3.6 Object.defineProperty(O, P, Attributes)
	$export($export.S + $export.F * !__webpack_require__(15), 'Object', {defineProperty: __webpack_require__(11).f});

/***/ },
/* 43 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	exports.__esModule = true;

	var _assign = __webpack_require__(2);

	var _assign2 = _interopRequireDefault(_assign);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = _assign2.default || function (target) {
	  for (var i = 1; i < arguments.length; i++) {
	    var source = arguments[i];

	    for (var key in source) {
	      if (Object.prototype.hasOwnProperty.call(source, key)) {
	        target[key] = source[key];
	      }
	    }
	  }

	  return target;
	};

/***/ },
/* 44 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;

	exports.default = function (obj, keys) {
	  var target = {};

	  for (var i in obj) {
	    if (keys.indexOf(i) >= 0) continue;
	    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
	    target[i] = obj[i];
	  }

	  return target;
	};

/***/ },
/* 45 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(46), __esModule: true };

/***/ },
/* 46 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(47);
	module.exports = __webpack_require__(7).Object.getPrototypeOf;

/***/ },
/* 47 */
/***/ function(module, exports, __webpack_require__) {

	// 19.1.2.9 Object.getPrototypeOf(O)
	var toObject        = __webpack_require__(38)
	  , $getPrototypeOf = __webpack_require__(48);

	__webpack_require__(49)('getPrototypeOf', function(){
	  return function getPrototypeOf(it){
	    return $getPrototypeOf(toObject(it));
	  };
	});

/***/ },
/* 48 */
/***/ function(module, exports, __webpack_require__) {

	// 19.1.2.9 / 15.2.3.2 Object.getPrototypeOf(O)
	var has         = __webpack_require__(23)
	  , toObject    = __webpack_require__(38)
	  , IE_PROTO    = __webpack_require__(32)('IE_PROTO')
	  , ObjectProto = Object.prototype;

	module.exports = Object.getPrototypeOf || function(O){
	  O = toObject(O);
	  if(has(O, IE_PROTO))return O[IE_PROTO];
	  if(typeof O.constructor == 'function' && O instanceof O.constructor){
	    return O.constructor.prototype;
	  } return O instanceof Object ? ObjectProto : null;
	};

/***/ },
/* 49 */
/***/ function(module, exports, __webpack_require__) {

	// most Object methods by ES6 should accept primitives
	var $export = __webpack_require__(5)
	  , core    = __webpack_require__(7)
	  , fails   = __webpack_require__(16);
	module.exports = function(KEY, exec){
	  var fn  = (core.Object || {})[KEY] || Object[KEY]
	    , exp = {};
	  exp[KEY] = exec(fn);
	  $export($export.S + $export.F * fails(function(){ fn(1); }), 'Object', exp);
	};

/***/ },
/* 50 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;

	exports.default = function (instance, Constructor) {
	  if (!(instance instanceof Constructor)) {
	    throw new TypeError("Cannot call a class as a function");
	  }
	};

/***/ },
/* 51 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	exports.__esModule = true;

	var _defineProperty = __webpack_require__(40);

	var _defineProperty2 = _interopRequireDefault(_defineProperty);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = function () {
	  function defineProperties(target, props) {
	    for (var i = 0; i < props.length; i++) {
	      var descriptor = props[i];
	      descriptor.enumerable = descriptor.enumerable || false;
	      descriptor.configurable = true;
	      if ("value" in descriptor) descriptor.writable = true;
	      (0, _defineProperty2.default)(target, descriptor.key, descriptor);
	    }
	  }

	  return function (Constructor, protoProps, staticProps) {
	    if (protoProps) defineProperties(Constructor.prototype, protoProps);
	    if (staticProps) defineProperties(Constructor, staticProps);
	    return Constructor;
	  };
	}();

/***/ },
/* 52 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	exports.__esModule = true;

	var _typeof2 = __webpack_require__(53);

	var _typeof3 = _interopRequireDefault(_typeof2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = function (self, call) {
	  if (!self) {
	    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	  }

	  return call && ((typeof call === "undefined" ? "undefined" : (0, _typeof3.default)(call)) === "object" || typeof call === "function") ? call : self;
	};

/***/ },
/* 53 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	exports.__esModule = true;

	var _iterator = __webpack_require__(54);

	var _iterator2 = _interopRequireDefault(_iterator);

	var _symbol = __webpack_require__(73);

	var _symbol2 = _interopRequireDefault(_symbol);

	var _typeof = typeof _symbol2.default === "function" && typeof _iterator2.default === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default ? "symbol" : typeof obj; };

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = typeof _symbol2.default === "function" && _typeof(_iterator2.default) === "symbol" ? function (obj) {
	  return typeof obj === "undefined" ? "undefined" : _typeof(obj);
	} : function (obj) {
	  return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
	};

/***/ },
/* 54 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(55), __esModule: true };

/***/ },
/* 55 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(56);
	__webpack_require__(68);
	module.exports = __webpack_require__(72).f('iterator');

/***/ },
/* 56 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var $at  = __webpack_require__(57)(true);

	// 21.1.3.27 String.prototype[@@iterator]()
	__webpack_require__(58)(String, 'String', function(iterated){
	  this._t = String(iterated); // target
	  this._i = 0;                // next index
	// 21.1.5.2.1 %StringIteratorPrototype%.next()
	}, function(){
	  var O     = this._t
	    , index = this._i
	    , point;
	  if(index >= O.length)return {value: undefined, done: true};
	  point = $at(O, index);
	  this._i += point.length;
	  return {value: point, done: false};
	});

/***/ },
/* 57 */
/***/ function(module, exports, __webpack_require__) {

	var toInteger = __webpack_require__(30)
	  , defined   = __webpack_require__(27);
	// true  -> String#at
	// false -> String#codePointAt
	module.exports = function(TO_STRING){
	  return function(that, pos){
	    var s = String(defined(that))
	      , i = toInteger(pos)
	      , l = s.length
	      , a, b;
	    if(i < 0 || i >= l)return TO_STRING ? '' : undefined;
	    a = s.charCodeAt(i);
	    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
	      ? TO_STRING ? s.charAt(i) : a
	      : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
	  };
	};

/***/ },
/* 58 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var LIBRARY        = __webpack_require__(59)
	  , $export        = __webpack_require__(5)
	  , redefine       = __webpack_require__(60)
	  , hide           = __webpack_require__(10)
	  , has            = __webpack_require__(23)
	  , Iterators      = __webpack_require__(61)
	  , $iterCreate    = __webpack_require__(62)
	  , setToStringTag = __webpack_require__(66)
	  , getPrototypeOf = __webpack_require__(48)
	  , ITERATOR       = __webpack_require__(67)('iterator')
	  , BUGGY          = !([].keys && 'next' in [].keys()) // Safari has buggy iterators w/o `next`
	  , FF_ITERATOR    = '@@iterator'
	  , KEYS           = 'keys'
	  , VALUES         = 'values';

	var returnThis = function(){ return this; };

	module.exports = function(Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED){
	  $iterCreate(Constructor, NAME, next);
	  var getMethod = function(kind){
	    if(!BUGGY && kind in proto)return proto[kind];
	    switch(kind){
	      case KEYS: return function keys(){ return new Constructor(this, kind); };
	      case VALUES: return function values(){ return new Constructor(this, kind); };
	    } return function entries(){ return new Constructor(this, kind); };
	  };
	  var TAG        = NAME + ' Iterator'
	    , DEF_VALUES = DEFAULT == VALUES
	    , VALUES_BUG = false
	    , proto      = Base.prototype
	    , $native    = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT]
	    , $default   = $native || getMethod(DEFAULT)
	    , $entries   = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined
	    , $anyNative = NAME == 'Array' ? proto.entries || $native : $native
	    , methods, key, IteratorPrototype;
	  // Fix native
	  if($anyNative){
	    IteratorPrototype = getPrototypeOf($anyNative.call(new Base));
	    if(IteratorPrototype !== Object.prototype){
	      // Set @@toStringTag to native iterators
	      setToStringTag(IteratorPrototype, TAG, true);
	      // fix for some old engines
	      if(!LIBRARY && !has(IteratorPrototype, ITERATOR))hide(IteratorPrototype, ITERATOR, returnThis);
	    }
	  }
	  // fix Array#{values, @@iterator}.name in V8 / FF
	  if(DEF_VALUES && $native && $native.name !== VALUES){
	    VALUES_BUG = true;
	    $default = function values(){ return $native.call(this); };
	  }
	  // Define iterator
	  if((!LIBRARY || FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])){
	    hide(proto, ITERATOR, $default);
	  }
	  // Plug for library
	  Iterators[NAME] = $default;
	  Iterators[TAG]  = returnThis;
	  if(DEFAULT){
	    methods = {
	      values:  DEF_VALUES ? $default : getMethod(VALUES),
	      keys:    IS_SET     ? $default : getMethod(KEYS),
	      entries: $entries
	    };
	    if(FORCED)for(key in methods){
	      if(!(key in proto))redefine(proto, key, methods[key]);
	    } else $export($export.P + $export.F * (BUGGY || VALUES_BUG), NAME, methods);
	  }
	  return methods;
	};

/***/ },
/* 59 */
/***/ function(module, exports) {

	module.exports = true;

/***/ },
/* 60 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(10);

/***/ },
/* 61 */
/***/ function(module, exports) {

	module.exports = {};

/***/ },
/* 62 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var create         = __webpack_require__(63)
	  , descriptor     = __webpack_require__(19)
	  , setToStringTag = __webpack_require__(66)
	  , IteratorPrototype = {};

	// 25.1.2.1.1 %IteratorPrototype%[@@iterator]()
	__webpack_require__(10)(IteratorPrototype, __webpack_require__(67)('iterator'), function(){ return this; });

	module.exports = function(Constructor, NAME, next){
	  Constructor.prototype = create(IteratorPrototype, {next: descriptor(1, next)});
	  setToStringTag(Constructor, NAME + ' Iterator');
	};

/***/ },
/* 63 */
/***/ function(module, exports, __webpack_require__) {

	// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
	var anObject    = __webpack_require__(12)
	  , dPs         = __webpack_require__(64)
	  , enumBugKeys = __webpack_require__(35)
	  , IE_PROTO    = __webpack_require__(32)('IE_PROTO')
	  , Empty       = function(){ /* empty */ }
	  , PROTOTYPE   = 'prototype';

	// Create object with fake `null` prototype: use iframe Object with cleared prototype
	var createDict = function(){
	  // Thrash, waste and sodomy: IE GC bug
	  var iframe = __webpack_require__(17)('iframe')
	    , i      = enumBugKeys.length
	    , lt     = '<'
	    , gt     = '>'
	    , iframeDocument;
	  iframe.style.display = 'none';
	  __webpack_require__(65).appendChild(iframe);
	  iframe.src = 'javascript:'; // eslint-disable-line no-script-url
	  // createDict = iframe.contentWindow.Object;
	  // html.removeChild(iframe);
	  iframeDocument = iframe.contentWindow.document;
	  iframeDocument.open();
	  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
	  iframeDocument.close();
	  createDict = iframeDocument.F;
	  while(i--)delete createDict[PROTOTYPE][enumBugKeys[i]];
	  return createDict();
	};

	module.exports = Object.create || function create(O, Properties){
	  var result;
	  if(O !== null){
	    Empty[PROTOTYPE] = anObject(O);
	    result = new Empty;
	    Empty[PROTOTYPE] = null;
	    // add "__proto__" for Object.getPrototypeOf polyfill
	    result[IE_PROTO] = O;
	  } else result = createDict();
	  return Properties === undefined ? result : dPs(result, Properties);
	};


/***/ },
/* 64 */
/***/ function(module, exports, __webpack_require__) {

	var dP       = __webpack_require__(11)
	  , anObject = __webpack_require__(12)
	  , getKeys  = __webpack_require__(21);

	module.exports = __webpack_require__(15) ? Object.defineProperties : function defineProperties(O, Properties){
	  anObject(O);
	  var keys   = getKeys(Properties)
	    , length = keys.length
	    , i = 0
	    , P;
	  while(length > i)dP.f(O, P = keys[i++], Properties[P]);
	  return O;
	};

/***/ },
/* 65 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(6).document && document.documentElement;

/***/ },
/* 66 */
/***/ function(module, exports, __webpack_require__) {

	var def = __webpack_require__(11).f
	  , has = __webpack_require__(23)
	  , TAG = __webpack_require__(67)('toStringTag');

	module.exports = function(it, tag, stat){
	  if(it && !has(it = stat ? it : it.prototype, TAG))def(it, TAG, {configurable: true, value: tag});
	};

/***/ },
/* 67 */
/***/ function(module, exports, __webpack_require__) {

	var store      = __webpack_require__(33)('wks')
	  , uid        = __webpack_require__(34)
	  , Symbol     = __webpack_require__(6).Symbol
	  , USE_SYMBOL = typeof Symbol == 'function';

	var $exports = module.exports = function(name){
	  return store[name] || (store[name] =
	    USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : uid)('Symbol.' + name));
	};

	$exports.store = store;

/***/ },
/* 68 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(69);
	var global        = __webpack_require__(6)
	  , hide          = __webpack_require__(10)
	  , Iterators     = __webpack_require__(61)
	  , TO_STRING_TAG = __webpack_require__(67)('toStringTag');

	for(var collections = ['NodeList', 'DOMTokenList', 'MediaList', 'StyleSheetList', 'CSSRuleList'], i = 0; i < 5; i++){
	  var NAME       = collections[i]
	    , Collection = global[NAME]
	    , proto      = Collection && Collection.prototype;
	  if(proto && !proto[TO_STRING_TAG])hide(proto, TO_STRING_TAG, NAME);
	  Iterators[NAME] = Iterators.Array;
	}

/***/ },
/* 69 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var addToUnscopables = __webpack_require__(70)
	  , step             = __webpack_require__(71)
	  , Iterators        = __webpack_require__(61)
	  , toIObject        = __webpack_require__(24);

	// 22.1.3.4 Array.prototype.entries()
	// 22.1.3.13 Array.prototype.keys()
	// 22.1.3.29 Array.prototype.values()
	// 22.1.3.30 Array.prototype[@@iterator]()
	module.exports = __webpack_require__(58)(Array, 'Array', function(iterated, kind){
	  this._t = toIObject(iterated); // target
	  this._i = 0;                   // next index
	  this._k = kind;                // kind
	// 22.1.5.2.1 %ArrayIteratorPrototype%.next()
	}, function(){
	  var O     = this._t
	    , kind  = this._k
	    , index = this._i++;
	  if(!O || index >= O.length){
	    this._t = undefined;
	    return step(1);
	  }
	  if(kind == 'keys'  )return step(0, index);
	  if(kind == 'values')return step(0, O[index]);
	  return step(0, [index, O[index]]);
	}, 'values');

	// argumentsList[@@iterator] is %ArrayProto_values% (9.4.4.6, 9.4.4.7)
	Iterators.Arguments = Iterators.Array;

	addToUnscopables('keys');
	addToUnscopables('values');
	addToUnscopables('entries');

/***/ },
/* 70 */
/***/ function(module, exports) {

	module.exports = function(){ /* empty */ };

/***/ },
/* 71 */
/***/ function(module, exports) {

	module.exports = function(done, value){
	  return {value: value, done: !!done};
	};

/***/ },
/* 72 */
/***/ function(module, exports, __webpack_require__) {

	exports.f = __webpack_require__(67);

/***/ },
/* 73 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(74), __esModule: true };

/***/ },
/* 74 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(75);
	__webpack_require__(84);
	__webpack_require__(85);
	__webpack_require__(86);
	module.exports = __webpack_require__(7).Symbol;

/***/ },
/* 75 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	// ECMAScript 6 symbols shim
	var global         = __webpack_require__(6)
	  , has            = __webpack_require__(23)
	  , DESCRIPTORS    = __webpack_require__(15)
	  , $export        = __webpack_require__(5)
	  , redefine       = __webpack_require__(60)
	  , META           = __webpack_require__(76).KEY
	  , $fails         = __webpack_require__(16)
	  , shared         = __webpack_require__(33)
	  , setToStringTag = __webpack_require__(66)
	  , uid            = __webpack_require__(34)
	  , wks            = __webpack_require__(67)
	  , wksExt         = __webpack_require__(72)
	  , wksDefine      = __webpack_require__(77)
	  , keyOf          = __webpack_require__(78)
	  , enumKeys       = __webpack_require__(79)
	  , isArray        = __webpack_require__(80)
	  , anObject       = __webpack_require__(12)
	  , toIObject      = __webpack_require__(24)
	  , toPrimitive    = __webpack_require__(18)
	  , createDesc     = __webpack_require__(19)
	  , _create        = __webpack_require__(63)
	  , gOPNExt        = __webpack_require__(81)
	  , $GOPD          = __webpack_require__(83)
	  , $DP            = __webpack_require__(11)
	  , $keys          = __webpack_require__(21)
	  , gOPD           = $GOPD.f
	  , dP             = $DP.f
	  , gOPN           = gOPNExt.f
	  , $Symbol        = global.Symbol
	  , $JSON          = global.JSON
	  , _stringify     = $JSON && $JSON.stringify
	  , PROTOTYPE      = 'prototype'
	  , HIDDEN         = wks('_hidden')
	  , TO_PRIMITIVE   = wks('toPrimitive')
	  , isEnum         = {}.propertyIsEnumerable
	  , SymbolRegistry = shared('symbol-registry')
	  , AllSymbols     = shared('symbols')
	  , OPSymbols      = shared('op-symbols')
	  , ObjectProto    = Object[PROTOTYPE]
	  , USE_NATIVE     = typeof $Symbol == 'function'
	  , QObject        = global.QObject;
	// Don't use setters in Qt Script, https://github.com/zloirock/core-js/issues/173
	var setter = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;

	// fallback for old Android, https://code.google.com/p/v8/issues/detail?id=687
	var setSymbolDesc = DESCRIPTORS && $fails(function(){
	  return _create(dP({}, 'a', {
	    get: function(){ return dP(this, 'a', {value: 7}).a; }
	  })).a != 7;
	}) ? function(it, key, D){
	  var protoDesc = gOPD(ObjectProto, key);
	  if(protoDesc)delete ObjectProto[key];
	  dP(it, key, D);
	  if(protoDesc && it !== ObjectProto)dP(ObjectProto, key, protoDesc);
	} : dP;

	var wrap = function(tag){
	  var sym = AllSymbols[tag] = _create($Symbol[PROTOTYPE]);
	  sym._k = tag;
	  return sym;
	};

	var isSymbol = USE_NATIVE && typeof $Symbol.iterator == 'symbol' ? function(it){
	  return typeof it == 'symbol';
	} : function(it){
	  return it instanceof $Symbol;
	};

	var $defineProperty = function defineProperty(it, key, D){
	  if(it === ObjectProto)$defineProperty(OPSymbols, key, D);
	  anObject(it);
	  key = toPrimitive(key, true);
	  anObject(D);
	  if(has(AllSymbols, key)){
	    if(!D.enumerable){
	      if(!has(it, HIDDEN))dP(it, HIDDEN, createDesc(1, {}));
	      it[HIDDEN][key] = true;
	    } else {
	      if(has(it, HIDDEN) && it[HIDDEN][key])it[HIDDEN][key] = false;
	      D = _create(D, {enumerable: createDesc(0, false)});
	    } return setSymbolDesc(it, key, D);
	  } return dP(it, key, D);
	};
	var $defineProperties = function defineProperties(it, P){
	  anObject(it);
	  var keys = enumKeys(P = toIObject(P))
	    , i    = 0
	    , l = keys.length
	    , key;
	  while(l > i)$defineProperty(it, key = keys[i++], P[key]);
	  return it;
	};
	var $create = function create(it, P){
	  return P === undefined ? _create(it) : $defineProperties(_create(it), P);
	};
	var $propertyIsEnumerable = function propertyIsEnumerable(key){
	  var E = isEnum.call(this, key = toPrimitive(key, true));
	  if(this === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key))return false;
	  return E || !has(this, key) || !has(AllSymbols, key) || has(this, HIDDEN) && this[HIDDEN][key] ? E : true;
	};
	var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(it, key){
	  it  = toIObject(it);
	  key = toPrimitive(key, true);
	  if(it === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key))return;
	  var D = gOPD(it, key);
	  if(D && has(AllSymbols, key) && !(has(it, HIDDEN) && it[HIDDEN][key]))D.enumerable = true;
	  return D;
	};
	var $getOwnPropertyNames = function getOwnPropertyNames(it){
	  var names  = gOPN(toIObject(it))
	    , result = []
	    , i      = 0
	    , key;
	  while(names.length > i){
	    if(!has(AllSymbols, key = names[i++]) && key != HIDDEN && key != META)result.push(key);
	  } return result;
	};
	var $getOwnPropertySymbols = function getOwnPropertySymbols(it){
	  var IS_OP  = it === ObjectProto
	    , names  = gOPN(IS_OP ? OPSymbols : toIObject(it))
	    , result = []
	    , i      = 0
	    , key;
	  while(names.length > i){
	    if(has(AllSymbols, key = names[i++]) && (IS_OP ? has(ObjectProto, key) : true))result.push(AllSymbols[key]);
	  } return result;
	};

	// 19.4.1.1 Symbol([description])
	if(!USE_NATIVE){
	  $Symbol = function Symbol(){
	    if(this instanceof $Symbol)throw TypeError('Symbol is not a constructor!');
	    var tag = uid(arguments.length > 0 ? arguments[0] : undefined);
	    var $set = function(value){
	      if(this === ObjectProto)$set.call(OPSymbols, value);
	      if(has(this, HIDDEN) && has(this[HIDDEN], tag))this[HIDDEN][tag] = false;
	      setSymbolDesc(this, tag, createDesc(1, value));
	    };
	    if(DESCRIPTORS && setter)setSymbolDesc(ObjectProto, tag, {configurable: true, set: $set});
	    return wrap(tag);
	  };
	  redefine($Symbol[PROTOTYPE], 'toString', function toString(){
	    return this._k;
	  });

	  $GOPD.f = $getOwnPropertyDescriptor;
	  $DP.f   = $defineProperty;
	  __webpack_require__(82).f = gOPNExt.f = $getOwnPropertyNames;
	  __webpack_require__(37).f  = $propertyIsEnumerable;
	  __webpack_require__(36).f = $getOwnPropertySymbols;

	  if(DESCRIPTORS && !__webpack_require__(59)){
	    redefine(ObjectProto, 'propertyIsEnumerable', $propertyIsEnumerable, true);
	  }

	  wksExt.f = function(name){
	    return wrap(wks(name));
	  }
	}

	$export($export.G + $export.W + $export.F * !USE_NATIVE, {Symbol: $Symbol});

	for(var symbols = (
	  // 19.4.2.2, 19.4.2.3, 19.4.2.4, 19.4.2.6, 19.4.2.8, 19.4.2.9, 19.4.2.10, 19.4.2.11, 19.4.2.12, 19.4.2.13, 19.4.2.14
	  'hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables'
	).split(','), i = 0; symbols.length > i; )wks(symbols[i++]);

	for(var symbols = $keys(wks.store), i = 0; symbols.length > i; )wksDefine(symbols[i++]);

	$export($export.S + $export.F * !USE_NATIVE, 'Symbol', {
	  // 19.4.2.1 Symbol.for(key)
	  'for': function(key){
	    return has(SymbolRegistry, key += '')
	      ? SymbolRegistry[key]
	      : SymbolRegistry[key] = $Symbol(key);
	  },
	  // 19.4.2.5 Symbol.keyFor(sym)
	  keyFor: function keyFor(key){
	    if(isSymbol(key))return keyOf(SymbolRegistry, key);
	    throw TypeError(key + ' is not a symbol!');
	  },
	  useSetter: function(){ setter = true; },
	  useSimple: function(){ setter = false; }
	});

	$export($export.S + $export.F * !USE_NATIVE, 'Object', {
	  // 19.1.2.2 Object.create(O [, Properties])
	  create: $create,
	  // 19.1.2.4 Object.defineProperty(O, P, Attributes)
	  defineProperty: $defineProperty,
	  // 19.1.2.3 Object.defineProperties(O, Properties)
	  defineProperties: $defineProperties,
	  // 19.1.2.6 Object.getOwnPropertyDescriptor(O, P)
	  getOwnPropertyDescriptor: $getOwnPropertyDescriptor,
	  // 19.1.2.7 Object.getOwnPropertyNames(O)
	  getOwnPropertyNames: $getOwnPropertyNames,
	  // 19.1.2.8 Object.getOwnPropertySymbols(O)
	  getOwnPropertySymbols: $getOwnPropertySymbols
	});

	// 24.3.2 JSON.stringify(value [, replacer [, space]])
	$JSON && $export($export.S + $export.F * (!USE_NATIVE || $fails(function(){
	  var S = $Symbol();
	  // MS Edge converts symbol values to JSON as {}
	  // WebKit converts symbol values to JSON as null
	  // V8 throws on boxed symbols
	  return _stringify([S]) != '[null]' || _stringify({a: S}) != '{}' || _stringify(Object(S)) != '{}';
	})), 'JSON', {
	  stringify: function stringify(it){
	    if(it === undefined || isSymbol(it))return; // IE8 returns string on undefined
	    var args = [it]
	      , i    = 1
	      , replacer, $replacer;
	    while(arguments.length > i)args.push(arguments[i++]);
	    replacer = args[1];
	    if(typeof replacer == 'function')$replacer = replacer;
	    if($replacer || !isArray(replacer))replacer = function(key, value){
	      if($replacer)value = $replacer.call(this, key, value);
	      if(!isSymbol(value))return value;
	    };
	    args[1] = replacer;
	    return _stringify.apply($JSON, args);
	  }
	});

	// 19.4.3.4 Symbol.prototype[@@toPrimitive](hint)
	$Symbol[PROTOTYPE][TO_PRIMITIVE] || __webpack_require__(10)($Symbol[PROTOTYPE], TO_PRIMITIVE, $Symbol[PROTOTYPE].valueOf);
	// 19.4.3.5 Symbol.prototype[@@toStringTag]
	setToStringTag($Symbol, 'Symbol');
	// 20.2.1.9 Math[@@toStringTag]
	setToStringTag(Math, 'Math', true);
	// 24.3.3 JSON[@@toStringTag]
	setToStringTag(global.JSON, 'JSON', true);

/***/ },
/* 76 */
/***/ function(module, exports, __webpack_require__) {

	var META     = __webpack_require__(34)('meta')
	  , isObject = __webpack_require__(13)
	  , has      = __webpack_require__(23)
	  , setDesc  = __webpack_require__(11).f
	  , id       = 0;
	var isExtensible = Object.isExtensible || function(){
	  return true;
	};
	var FREEZE = !__webpack_require__(16)(function(){
	  return isExtensible(Object.preventExtensions({}));
	});
	var setMeta = function(it){
	  setDesc(it, META, {value: {
	    i: 'O' + ++id, // object ID
	    w: {}          // weak collections IDs
	  }});
	};
	var fastKey = function(it, create){
	  // return primitive with prefix
	  if(!isObject(it))return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
	  if(!has(it, META)){
	    // can't set metadata to uncaught frozen object
	    if(!isExtensible(it))return 'F';
	    // not necessary to add metadata
	    if(!create)return 'E';
	    // add missing metadata
	    setMeta(it);
	  // return object ID
	  } return it[META].i;
	};
	var getWeak = function(it, create){
	  if(!has(it, META)){
	    // can't set metadata to uncaught frozen object
	    if(!isExtensible(it))return true;
	    // not necessary to add metadata
	    if(!create)return false;
	    // add missing metadata
	    setMeta(it);
	  // return hash weak collections IDs
	  } return it[META].w;
	};
	// add metadata on freeze-family methods calling
	var onFreeze = function(it){
	  if(FREEZE && meta.NEED && isExtensible(it) && !has(it, META))setMeta(it);
	  return it;
	};
	var meta = module.exports = {
	  KEY:      META,
	  NEED:     false,
	  fastKey:  fastKey,
	  getWeak:  getWeak,
	  onFreeze: onFreeze
	};

/***/ },
/* 77 */
/***/ function(module, exports, __webpack_require__) {

	var global         = __webpack_require__(6)
	  , core           = __webpack_require__(7)
	  , LIBRARY        = __webpack_require__(59)
	  , wksExt         = __webpack_require__(72)
	  , defineProperty = __webpack_require__(11).f;
	module.exports = function(name){
	  var $Symbol = core.Symbol || (core.Symbol = LIBRARY ? {} : global.Symbol || {});
	  if(name.charAt(0) != '_' && !(name in $Symbol))defineProperty($Symbol, name, {value: wksExt.f(name)});
	};

/***/ },
/* 78 */
/***/ function(module, exports, __webpack_require__) {

	var getKeys   = __webpack_require__(21)
	  , toIObject = __webpack_require__(24);
	module.exports = function(object, el){
	  var O      = toIObject(object)
	    , keys   = getKeys(O)
	    , length = keys.length
	    , index  = 0
	    , key;
	  while(length > index)if(O[key = keys[index++]] === el)return key;
	};

/***/ },
/* 79 */
/***/ function(module, exports, __webpack_require__) {

	// all enumerable object keys, includes symbols
	var getKeys = __webpack_require__(21)
	  , gOPS    = __webpack_require__(36)
	  , pIE     = __webpack_require__(37);
	module.exports = function(it){
	  var result     = getKeys(it)
	    , getSymbols = gOPS.f;
	  if(getSymbols){
	    var symbols = getSymbols(it)
	      , isEnum  = pIE.f
	      , i       = 0
	      , key;
	    while(symbols.length > i)if(isEnum.call(it, key = symbols[i++]))result.push(key);
	  } return result;
	};

/***/ },
/* 80 */
/***/ function(module, exports, __webpack_require__) {

	// 7.2.2 IsArray(argument)
	var cof = __webpack_require__(26);
	module.exports = Array.isArray || function isArray(arg){
	  return cof(arg) == 'Array';
	};

/***/ },
/* 81 */
/***/ function(module, exports, __webpack_require__) {

	// fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window
	var toIObject = __webpack_require__(24)
	  , gOPN      = __webpack_require__(82).f
	  , toString  = {}.toString;

	var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
	  ? Object.getOwnPropertyNames(window) : [];

	var getWindowNames = function(it){
	  try {
	    return gOPN(it);
	  } catch(e){
	    return windowNames.slice();
	  }
	};

	module.exports.f = function getOwnPropertyNames(it){
	  return windowNames && toString.call(it) == '[object Window]' ? getWindowNames(it) : gOPN(toIObject(it));
	};


/***/ },
/* 82 */
/***/ function(module, exports, __webpack_require__) {

	// 19.1.2.7 / 15.2.3.4 Object.getOwnPropertyNames(O)
	var $keys      = __webpack_require__(22)
	  , hiddenKeys = __webpack_require__(35).concat('length', 'prototype');

	exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O){
	  return $keys(O, hiddenKeys);
	};

/***/ },
/* 83 */
/***/ function(module, exports, __webpack_require__) {

	var pIE            = __webpack_require__(37)
	  , createDesc     = __webpack_require__(19)
	  , toIObject      = __webpack_require__(24)
	  , toPrimitive    = __webpack_require__(18)
	  , has            = __webpack_require__(23)
	  , IE8_DOM_DEFINE = __webpack_require__(14)
	  , gOPD           = Object.getOwnPropertyDescriptor;

	exports.f = __webpack_require__(15) ? gOPD : function getOwnPropertyDescriptor(O, P){
	  O = toIObject(O);
	  P = toPrimitive(P, true);
	  if(IE8_DOM_DEFINE)try {
	    return gOPD(O, P);
	  } catch(e){ /* empty */ }
	  if(has(O, P))return createDesc(!pIE.f.call(O, P), O[P]);
	};

/***/ },
/* 84 */
/***/ function(module, exports) {

	

/***/ },
/* 85 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(77)('asyncIterator');

/***/ },
/* 86 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(77)('observable');

/***/ },
/* 87 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	exports.__esModule = true;

	var _setPrototypeOf = __webpack_require__(88);

	var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

	var _create = __webpack_require__(92);

	var _create2 = _interopRequireDefault(_create);

	var _typeof2 = __webpack_require__(53);

	var _typeof3 = _interopRequireDefault(_typeof2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = function (subClass, superClass) {
	  if (typeof superClass !== "function" && superClass !== null) {
	    throw new TypeError("Super expression must either be null or a function, not " + (typeof superClass === "undefined" ? "undefined" : (0, _typeof3.default)(superClass)));
	  }

	  subClass.prototype = (0, _create2.default)(superClass && superClass.prototype, {
	    constructor: {
	      value: subClass,
	      enumerable: false,
	      writable: true,
	      configurable: true
	    }
	  });
	  if (superClass) _setPrototypeOf2.default ? (0, _setPrototypeOf2.default)(subClass, superClass) : subClass.__proto__ = superClass;
	};

/***/ },
/* 88 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(89), __esModule: true };

/***/ },
/* 89 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(90);
	module.exports = __webpack_require__(7).Object.setPrototypeOf;

/***/ },
/* 90 */
/***/ function(module, exports, __webpack_require__) {

	// 19.1.3.19 Object.setPrototypeOf(O, proto)
	var $export = __webpack_require__(5);
	$export($export.S, 'Object', {setPrototypeOf: __webpack_require__(91).set});

/***/ },
/* 91 */
/***/ function(module, exports, __webpack_require__) {

	// Works with __proto__ only. Old v8 can't work with null proto objects.
	/* eslint-disable no-proto */
	var isObject = __webpack_require__(13)
	  , anObject = __webpack_require__(12);
	var check = function(O, proto){
	  anObject(O);
	  if(!isObject(proto) && proto !== null)throw TypeError(proto + ": can't set as prototype!");
	};
	module.exports = {
	  set: Object.setPrototypeOf || ('__proto__' in {} ? // eslint-disable-line
	    function(test, buggy, set){
	      try {
	        set = __webpack_require__(8)(Function.call, __webpack_require__(83).f(Object.prototype, '__proto__').set, 2);
	        set(test, []);
	        buggy = !(test instanceof Array);
	      } catch(e){ buggy = true; }
	      return function setPrototypeOf(O, proto){
	        check(O, proto);
	        if(buggy)O.__proto__ = proto;
	        else set(O, proto);
	        return O;
	      };
	    }({}, false) : undefined),
	  check: check
	};

/***/ },
/* 92 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(93), __esModule: true };

/***/ },
/* 93 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(94);
	var $Object = __webpack_require__(7).Object;
	module.exports = function create(P, D){
	  return $Object.create(P, D);
	};

/***/ },
/* 94 */
/***/ function(module, exports, __webpack_require__) {

	var $export = __webpack_require__(5)
	// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
	$export($export.S, 'Object', {create: __webpack_require__(63)});

/***/ },
/* 95 */
/***/ function(module, exports) {

	module.exports = undefined;

/***/ },
/* 96 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*!
	  Copyright (c) 2016 Jed Watson.
	  Licensed under the MIT License (MIT), see
	  http://jedwatson.github.io/classnames
	*/
	/* global define */

	(function () {
		'use strict';

		var hasOwn = {}.hasOwnProperty;

		function classNames () {
			var classes = [];

			for (var i = 0; i < arguments.length; i++) {
				var arg = arguments[i];
				if (!arg) continue;

				var argType = typeof arg;

				if (argType === 'string' || argType === 'number') {
					classes.push(arg);
				} else if (Array.isArray(arg)) {
					classes.push(classNames.apply(null, arg));
				} else if (argType === 'object') {
					for (var key in arg) {
						if (hasOwn.call(arg, key) && arg[key]) {
							classes.push(key);
						}
					}
				}
			}

			return classes.join(' ');
		}

		if (typeof module !== 'undefined' && module.exports) {
			module.exports = classNames;
		} else if (true) {
			// register as 'classnames', consistent with npm package name
			!(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_RESULT__ = function () {
				return classNames;
			}.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
		} else {
			window.classNames = classNames;
		}
	}());


/***/ },
/* 97 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _defineProperty2 = __webpack_require__(39);

	var _defineProperty3 = _interopRequireDefault(_defineProperty2);

	var _getPrototypeOf = __webpack_require__(45);

	var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

	var _classCallCheck2 = __webpack_require__(50);

	var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

	var _createClass2 = __webpack_require__(51);

	var _createClass3 = _interopRequireDefault(_createClass2);

	var _possibleConstructorReturn2 = __webpack_require__(52);

	var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

	var _inherits2 = __webpack_require__(87);

	var _inherits3 = _interopRequireDefault(_inherits2);

	var _react = __webpack_require__(95);

	var _react2 = _interopRequireDefault(_react);

	var _classnames = __webpack_require__(96);

	var _classnames2 = _interopRequireDefault(_classnames);

	var _util = __webpack_require__(98);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var TreeNode = function (_React$Component) {
	  (0, _inherits3.default)(TreeNode, _React$Component);

	  function TreeNode(props) {
	    (0, _classCallCheck3.default)(this, TreeNode);

	    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(TreeNode).call(this, props));

	    ['onExpand', 'onSelect', 'onCheck'].forEach(function (m) {
	      _this[m] = _this[m].bind(_this);
	    });
	    return _this;
	  }

	  (0, _createClass3.default)(TreeNode, [{
	    key: 'render',
	    value: function render() {
	      var _classes;

	      var props = this.props;
	      var value = props.value;
	      var text = props.text;
	      var selected = props.selected;
	      var multiple = props.multiple;
	      var commbox = props.commbox;
	      var checked = props.checked;
	      var expanded = props.expanded;
	      var qtip = props.qtip;
	      var prefixCls = props.prefixCls;
	      var className = props.className;
	      var children = props.children;

	      var classes = (_classes = {}, (0, _defineProperty3.default)(_classes, prefixCls, true), (0, _defineProperty3.default)(_classes, prefixCls + '-expanded', expanded), (0, _defineProperty3.default)(_classes, prefixCls + '-selected', selected), (0, _defineProperty3.default)(_classes, prefixCls + '-checked', checked), _classes);

	      return _react2.default.createElement(
	        'li',
	        { className: (0, _classnames2.default)(className, classes), 'aria-value': value, 'aria-expanded': expanded, 'aria-selected': selected },
	        this.isLeaf() ? _react2.default.createElement('i', null) : _react2.default.createElement('i', { className: 'icon-arrow', onClick: this.onExpand }),
	        this.renderCommbox(),
	        _react2.default.createElement(
	          'a',
	          { onClick: this.onSelect, onDoubleClick: this.onExpand, title: qtip || text },
	          text
	        ),
	        children
	      );
	    }
	  }, {
	    key: 'renderCommbox',
	    value: function renderCommbox() {
	      var _props = this.props;
	      var multiple = _props.multiple;
	      var commbox = _props.commbox;
	      var checked = _props.checked;

	      if (!commbox) {
	        return null;
	      }

	      var commboxPrefixCls = multiple ? 'icon-checkbox' : 'icon-radio';
	      var commboxCls = commboxPrefixCls + '-' + checked;

	      return _react2.default.createElement('i', { className: commboxCls, onClick: this.onCheck, 'aria-checked': checked });
	    }
	  }, {
	    key: 'isLeaf',
	    value: function isLeaf() {
	      var _props2 = this.props;
	      var leaf = _props2.leaf;
	      var expanded = _props2.expanded;
	      var children = _props2.children;

	      return leaf || expanded && !children;
	    }

	    /**
	     * 渲染子节点
	     */

	  }, {
	    key: 'renderChildren',
	    value: function renderChildren() {
	      var _this2 = this;

	      var _props3 = this.props;
	      var tree = _props3.tree;
	      var path = _props3.path;
	      var expanded = _props3.expanded;
	      var children = _props3.children;

	      if (!tree || !children || !expanded) {
	        return null;
	      }

	      return _react2.default.createElement(
	        'ul',
	        null,
	        _react2.default.Children.map(children, function (child, index) {
	          return tree.renderTreeNode(child, index, _this2, path);
	        }, tree)
	      );
	    }
	  }, {
	    key: 'onExpand',
	    value: function onExpand(e) {
	      var _props4 = this.props;
	      var expanded = _props4.expanded;
	      var onExpand = _props4.onExpand;

	      onExpand(!expanded, this);
	    }
	  }, {
	    key: 'onSelect',
	    value: function onSelect() {
	      var _props5 = this.props;
	      var multiple = _props5.multiple;
	      var commbox = _props5.commbox;
	      var selected = _props5.selected;
	      var onSelect = _props5.onSelect;
	      var onCheck = _props5.onCheck;
	      // 单选，且存在commbox时，触发其onCheck事件

	      if (!multiple && commbox) {
	        onCheck((0, _util.booleanToCheckState)(!selected), this);
	      } else {
	        // 单选变更为已经选中的情况再次点击就直接关闭
	        //
	        multiple ? onSelect(!selected, this) : onSelect(true, this);
	      }
	    }
	  }, {
	    key: 'onCheck',
	    value: function onCheck() {
	      var _props6 = this.props;
	      var checked = _props6.checked;
	      var onCheck = _props6.onCheck;
	      // 选中状态，点击后，设为未选中状态，而半选或未选中状态在点击后，都将设为选中状态

	      onCheck(checked === _util.CHECKBOX_CHECKED ? _util.CHECKBOX_UNCHECKED : _util.CHECKBOX_CHECKED, this);
	    }
	  }]);
	  return TreeNode;
	}(_react2.default.Component);

	TreeNode.propTypes = {
	  /**
	   * 节点value(ID)
	   */
	  value: _react.PropTypes.string.isRequired,
	  /**
	   * 节点显示的文本信息
	   */
	  text: _react.PropTypes.string.isRequired,
	  /**
	   * 节点的提示信息
	   */
	  qtip: _react.PropTypes.string,
	  /**
	   * 是否选中
	   */
	  selected: _react.PropTypes.bool,
	  /**
	   * 是否选中checkbox（仅在commbox=true时有效）
	   * 其中0为未选中，1为选中，2为半选中
	   */
	  checked: _react.PropTypes.number,
	  /**
	   * 是否多选
	   * @type {[type]}
	   */
	  multiple: _react.PropTypes.bool,
	  /**
	   * 是否显示复选框（多选模式）
	   */
	  commbox: _react.PropTypes.bool,
	  /**
	   * 是否展开
	   */
	  expanded: _react.PropTypes.bool,
	  /**
	   * 是否设为disable，让它不可选
	   */
	  disabled: _react.PropTypes.bool,
	  /**
	   * 是否为叶节点
	   */
	  leaf: _react.PropTypes.bool,
	  /**
	   * 是否显示节点箭头
	   */
	  useArrow: _react.PropTypes.bool,
	  /**
	   * 选取节点时的回调事件
	   * @type {[function(isSelected, node)]}
	   */
	  onSelect: _react.PropTypes.func,
	  /**
	   * 选取commbox时的回调事件
	   * @type {[function(isChecked, node)]}
	   */
	  onCheck: _react.PropTypes.func,
	  /**
	   * 展开或收缩节点时的回调事件
	   * @type {[function(isExpanded, node)]}
	   */
	  onExpand: _react.PropTypes.func
	};

	TreeNode.defaultProps = {
	  prefixCls: 'rt-tree-node',
	  onSelect: _util.noop,
	  onCheck: _util.noop,
	  onExpand: _util.noop
	};

	exports.default = TreeNode;

/***/ },
/* 98 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.noop = noop;
	exports.checkStateToBoolean = checkStateToBoolean;
	exports.booleanToCheckState = booleanToCheckState;
	exports.ownerDocument = ownerDocument;
	exports.ownerWindow = ownerWindow;
	exports.addEventListener = addEventListener;
	var TREE_ELEMENT = exports.TREE_ELEMENT = 'Tree';
	var LIST_ELEMENT = exports.LIST_ELEMENT = 'List';
	var ACTION_SELECT = exports.ACTION_SELECT = 'SELECT';
	var ACTION_CHECK = exports.ACTION_CHECK = 'CHECK';
	var CHECKBOX_CHECKED = exports.CHECKBOX_CHECKED = 1;
	var CHECKBOX_UNCHECKED = exports.CHECKBOX_UNCHECKED = 0;
	var CHECKBOX_PARTIAL = exports.CHECKBOX_PARTIAL = 2;
	var ROOT_ID = exports.ROOT_ID = '-1';

	function noop() {}

	function checkStateToBoolean(state) {
	  return state === CHECKBOX_CHECKED ? true : false;
	}

	function booleanToCheckState(state) {
	  return state ? CHECKBOX_CHECKED : CHECKBOX_UNCHECKED;
	}

	function ownerDocument(node) {
	  return node && node.ownerDocument || document;
	}

	function ownerWindow(node) {
	  var doc = ownerDocument(node);
	  return doc && doc.defaultView || doc.parentWindow;
	}

	var on = exports.on = function () {
	  if (document.addEventListener) return function (node, eventName, handler, capture) {
	    return node.addEventListener(eventName, handler, capture || false);
	  };else if (document.attachEvent) return function (node, eventName, handler) {
	    return node.attachEvent('on' + eventName, handler);
	  };
	}();

	var off = exports.off = function () {
	  if (document.addEventListener) return function (node, eventName, handler, capture) {
	    return node.removeEventListener(eventName, handler, capture || false);
	  };else if (document.attachEvent) return function (node, eventName, handler) {
	    return node.detachEvent('on' + eventName, handler);
	  };
	}();

	function addEventListener(node, event, handler, capture) {
	  on(node, event, handler, capture);
	  return {
	    remove: function remove() {
	      off(node, event, handler);
	    }
	  };
	}

/***/ },
/* 99 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _typeof2 = __webpack_require__(53);

	var _typeof3 = _interopRequireDefault(_typeof2);

	var _classCallCheck2 = __webpack_require__(50);

	var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

	var _createClass2 = __webpack_require__(51);

	var _createClass3 = _interopRequireDefault(_createClass2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var Traverser = function () {
	  function Traverser(tree) {
	    (0, _classCallCheck3.default)(this, Traverser);

	    this._tree = tree;
	  }

	  /**
	    * Searches a tree in DFS fashion. Requires a search criteria to be provided.
	    *
	    * @method searchDFS
	    * @memberof Traverser
	    * @instance
	    * @param {function} criteria - MUST BE a callback function that specifies the search criteria.
	    * Criteria callback here receives {@link TreeNode#_data} in parameter and MUST return boolean
	    * indicating whether that data satisfies your criteria.
	    * @return {object} - first {@link TreeNode} in tree that matches the given criteria.
	    * @example
	    * // Search DFS
	    * var node = tree.searchDFS(function(data){
	    *  return data.key === '#greenapple';
	    * });
	    */


	  (0, _createClass3.default)(Traverser, [{
	    key: 'searchDFS',
	    value: function searchDFS(criteria) {

	      // Hold the node when found
	      var foundNode = null;

	      // Find node recursively
	      (function recur(node) {
	        if (node.matchCriteria(criteria)) {
	          foundNode = node;
	          return foundNode;
	        } else {
	          node._childNodes.some(recur);
	        }
	      })(this._tree._rootNode);

	      return foundNode;
	    }

	    /**
	     * Searches a tree in BFS fashion. Requires a search criteria to be provided.
	     *
	     * @method searchBFS
	     * @memberof Traverser
	     * @instance
	     * @param {function} criteria - MUST BE a callback function that specifies the search criteria.
	     * Criteria callback here receives {@link TreeNode#_data} in parameter and MUST return boolean
	     * indicating whether that data satisfies your criteria.
	     * @return {object} - first {@link TreeNode} in tree that matches the given criteria.
	     * @example
	     * // Search BFS
	     * var node = tree.searchBFS(function(data){
	     *  return data.key === '#greenapple';
	     * });
	     */

	  }, {
	    key: 'searchBFS',
	    value: function searchBFS(criteria) {

	      // Hold the node when found
	      var foundNode = null;

	      // Find nodes recursively
	      (function expand(queue) {
	        while (queue.length) {
	          var current = queue.splice(0, 1)[0];
	          if (current.matchCriteria(criteria)) {
	            foundNode = current;
	            return;
	          }
	          current._childNodes.forEach(function (_child) {
	            queue.push(_child);
	          });
	        }
	      })([this._tree._rootNode]);

	      return foundNode;
	    }

	    /**
	     * Traverses an entire tree in DFS fashion.
	     *
	     * @method traverseDFS
	     * @memberof Traverser
	     * @instance
	     * @param {function} callback - Gets triggered when @{link TreeNode} is explored. Explored node is passed as parameter to callback.
	     * @example
	     * // Traverse DFS
	     * tree.traverseDFS(function(node){
	     *  console.log(node.data);
	     * });
	     */

	  }, {
	    key: 'traverseDFS',
	    value: function traverseDFS(callback) {
	      (function recur(node) {
	        callback(node);
	        node._childNodes.forEach(recur);
	      })(this._tree._rootNode);
	    }

	    /**
	     * Traverses an entire tree in BFS fashion.
	     *
	     * @method traverseBFS
	     * @memberof Traverser
	     * @instance
	     * @param {function} callback - Gets triggered when node is explored. Explored node is passed as parameter to callback.
	     * @example
	     * // Traverse BFS
	     * tree.traverseBFS(function(node){
	     *  console.log(node.data);
	     * });
	     */

	  }, {
	    key: 'traverseBFS',
	    value: function traverseBFS(callback) {
	      (function expand(queue) {
	        while (queue.length) {
	          var current = queue.splice(0, 1)[0];
	          callback(current);
	          current._childNodes.forEach(function (_child) {
	            queue.push(_child);
	          });
	        }
	      })([this._tree._rootNode]);
	    }
	  }]);
	  return Traverser;
	}();

	var TreeNode = function () {
	  function TreeNode(data) {
	    (0, _classCallCheck3.default)(this, TreeNode);

	    /**
	       * Represents the parent node
	       *
	       * @property _parentNode
	       * @type {object}
	       * @default "null"
	       */
	    this._parentNode = null;

	    /**
	     * Represents the child nodes
	     *
	     * @property _childNodes
	     * @type {array}
	     * @default "[]"
	     */
	    this._childNodes = [];

	    /**
	     * Represents the data node has
	     *
	     * @property _data
	     * @type {object}
	     * @default "null"
	     */
	    this._data = data;

	    /**
	     * Depth of the node represents level in hierarchy
	     *
	     * @property _depth
	     * @type {number}
	     * @default -1
	     */
	    this._depth = -1;
	  }

	  (0, _createClass3.default)(TreeNode, [{
	    key: 'parentNode',
	    value: function parentNode() {
	      return this._parentNode;
	    }
	  }, {
	    key: 'childNodes',
	    value: function childNodes() {
	      return this._childNodes;
	    }
	  }, {
	    key: 'data',
	    value: function data(_data2) {
	      if (arguments.length > 0) {
	        this._data = _data2;
	      } else {
	        return this._data;
	      }
	    }
	  }, {
	    key: 'depth',
	    value: function depth() {
	      return this._depth;
	    }
	  }, {
	    key: 'matchCriteria',
	    value: function matchCriteria(criteria) {
	      return criteria(this._data);
	    }

	    /**
	      * get sibling nodes.
	      *
	      * @method siblings
	      * @memberof TreeNode
	      * @instance
	      * @return {array} - array of instances of {@link TreeNode}
	      */

	  }, {
	    key: 'siblings',
	    value: function siblings() {
	      var _this = this;

	      return !this._parentNode ? [] : this._parentNode._childNodes.filter(function (_child) {
	        return _child !== _this;
	      });
	    }

	    /**
	     * Gets an array of all ancestor nodes
	     *
	     * @method getAncestry
	     * @memberof TreeNode
	     * @instance
	     * @return {Array} - array of ancestor nodes
	     */

	  }, {
	    key: 'getAncestry',
	    value: function getAncestry() {
	      // Initialize empty array and node
	      var ancestors = [],
	          node = this;

	      // Loop over ancestors and add them in array
	      while (node.parentNode()) {
	        ancestors.push(node.parentNode());
	        node = node.parentNode();
	      }

	      return ancestors;
	    }
	  }, {
	    key: 'export',
	    value: function _export() {
	      var criteria = arguments.length <= 0 || arguments[0] === undefined ? function (data) {
	        return data;
	      } : arguments[0];

	      // Check if criteria is specified
	      if (!criteria || typeof criteria !== 'function') throw new Error('Export criteria not specified');

	      // Export every node recursively
	      var exportRecur = function exportRecur(node) {
	        var exported = node.matchCriteria(criteria);

	        if (!exported || (typeof exported === 'undefined' ? 'undefined' : (0, _typeof3.default)(exported)) !== 'object') {
	          throw new Error('Export criteria should always return an object and it cannot be null.');
	        } else {
	          exported.children = [];
	          node._childNodes.forEach(function (_child) {
	            exported.children.push(exportRecur(_child));
	          });

	          return exported;
	        }
	      };

	      return exportRecur(this);
	    }
	  }]);
	  return TreeNode;
	}();

	var Tree = function () {
	  function Tree() {
	    (0, _classCallCheck3.default)(this, Tree);

	    this._rootNode = null;
	    this._currentNode = null;
	    this._traverser = new Traverser(this);
	  }

	  (0, _createClass3.default)(Tree, [{
	    key: 'traverser',
	    value: function traverser() {
	      return this._traverser;
	    }
	  }, {
	    key: 'searchBFS',
	    value: function searchBFS(criteria) {
	      return this.traverser().searchBFS(criteria);
	    }
	  }, {
	    key: 'searchDFS',
	    value: function searchDFS(criteria) {
	      return this.traverser().searchDFS(criteria);
	    }
	  }, {
	    key: 'traverseBFS',
	    value: function traverseBFS(callback) {
	      return this.traverser().traverseBFS(callback);
	    }
	  }, {
	    key: 'traverseDFS',
	    value: function traverseDFS(callback) {
	      return this.traverser().traverseDFS(callback);
	    }
	  }, {
	    key: 'isEmpty',
	    value: function isEmpty() {
	      return this._rootNode === null && this._currentNode === null;
	    }
	  }, {
	    key: 'insert',
	    value: function insert(data) {
	      var node = new TreeNode(data);
	      if (this.isEmpty()) {
	        node._depth = 1;
	        this._rootNode = this._currentNode = node;
	      } else {
	        node._parentNode = this._currentNode;
	        this._currentNode._childNodes.push(node);
	        this._currentNode = node;
	        node.depth = node._parentNode._depth + 1;
	      }
	      return node;
	    }
	  }, {
	    key: 'insertToNode',
	    value: function insertToNode(node, data) {
	      var newNode = new TreeNode(data);
	      newNode._parentNode = node;
	      newNode._depth = newNode._parentNode._depth + 1;
	      node._childNodes.push(newNode);
	      this._currentNode = newNode;
	      return newNode;
	    }
	  }, {
	    key: 'trimBranchFrom',
	    value: function trimBranchFrom(node) {
	      // trim brach recursively
	      (function recur(node) {
	        node._childNodes.forEach(recur);
	        node._childNodes = [];
	        node._data = null;
	      })(node);

	      // Update Current Node
	      if (node._parentNode) {
	        node._parentNode._childNodes.splice(node._parentNode._childNodes.indexOf(node), 1);
	        this._currentNode = node._parentNode;
	      } else {
	        this._rootNode = this._currentNode = null;
	      }
	    }
	  }, {
	    key: 'export',
	    value: function _export(criteria) {
	      // Check if rootNode is not null
	      if (!this._rootNode) {
	        return null;
	      }

	      var treeData = this._rootNode.export(criteria);

	      if (treeData['__root']) {
	        return treeData.children;
	      }

	      return [treeData];
	    }
	  }, {
	    key: 'import',
	    value: function _import(data) {
	      var _this2 = this;

	      var criteria = arguments.length <= 1 || arguments[1] === undefined ? function (data) {
	        return data;
	      } : arguments[1];

	      // Empty all tree
	      if (this._rootNode) this.trimBranchFrom(this._rootNode);

	      // Set Current Node to root node as null
	      this._currentNode = this._rootNode = null;

	      // Import recursively
	      var importRecur = function importRecur(node, recurData) {

	        // Format data from given criteria
	        var _data = criteria(recurData);

	        // Create Root Node
	        if (!node) {
	          node = _this2.insert(_data);
	        } else {
	          node = _this2.insertToNode(node, _data);
	        }

	        // For Every Child
	        recurData.children && recurData.children.forEach(function (_child) {
	          importRecur(node, _child);
	        });
	      };

	      var treeData = void 0;

	      if (Array.isArray(data)) {
	        if (data.length === 1) {
	          treeData = data[0];
	        } else {
	          treeData = { __root: !0, children: data };
	        }
	      } else {
	        treeData = data;
	      }

	      importRecur(this._rootNode, treeData);

	      // Set Current Node to root node
	      this._currentNode = this._rootNode;

	      return this;
	    }
	  }]);
	  return Tree;
	}();

	exports.default = Tree;

/***/ },
/* 100 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _assign = __webpack_require__(2);

	var _assign2 = _interopRequireDefault(_assign);

	var _toConsumableArray2 = __webpack_require__(101);

	var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

	var _extends2 = __webpack_require__(43);

	var _extends3 = _interopRequireDefault(_extends2);

	var _objectWithoutProperties2 = __webpack_require__(44);

	var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

	var _getPrototypeOf = __webpack_require__(45);

	var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

	var _classCallCheck2 = __webpack_require__(50);

	var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

	var _createClass2 = __webpack_require__(51);

	var _createClass3 = _interopRequireDefault(_createClass2);

	var _possibleConstructorReturn2 = __webpack_require__(52);

	var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

	var _inherits2 = __webpack_require__(87);

	var _inherits3 = _interopRequireDefault(_inherits2);

	var _react = __webpack_require__(95);

	var _react2 = _interopRequireDefault(_react);

	var _reactDom = __webpack_require__(111);

	var _reactDom2 = _interopRequireDefault(_reactDom);

	var _classnames = __webpack_require__(96);

	var _classnames2 = _interopRequireDefault(_classnames);

	var _dataTree = __webpack_require__(99);

	var _dataTree2 = _interopRequireDefault(_dataTree);

	var _util = __webpack_require__(98);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var Select = function (_React$Component) {
	  (0, _inherits3.default)(Select, _React$Component);

	  function Select(props) {
	    (0, _classCallCheck3.default)(this, Select);

	    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Select).call(this, props));

	    ['onExpand', 'onSelect', 'onCheck', 'onChange', 'toggleMenuVisible', 'handleSearchInputChange', 'handleDocumentClick'].forEach(function (m) {
	      _this[m] = _this[m].bind(_this);
	    });

	    _this.state = {
	      /**
	       * 用于渲染下拉菜单的数据，取自于Tree.props.data或List.props.data
	       * 因为有搜索功能，这个data在搜索时会发生变化，所以需要在这里维护
	       * @type {[type]}
	       */
	      data: [],
	      /**
	       * 显示、隐藏下拉菜单的标识
	       * @type {Boolean}
	       */
	      menuVisible: false,
	      /**
	       * 树节点展开列表（搜索时用到，这里需要接管Tree.props.expanded）
	       * @type {Array}
	       */
	      expanded: [],
	      /**
	       * 下拉框在选择后，输入框显示的值
	       * @type {String}
	       */
	      inputValue: props.inputValue,
	      /**
	       * 搜索框显示的值
	       * @type {String}
	       */
	      searchInputValue: undefined
	    };
	    /**
	     * 初始化状态标识
	     * 数据一般都是异步加载，在生成Component时，由于props.data为空，导致props.defaultChecked等值无效
	     * 这里折中处理下，加一个状态标识，以便在props.data第一次不为空的情况下，取值于defaultChecked，而不是取值于checked
	     */
	    _this.initial = true;
	    /**
	     * 存储Tree, List组件的原有数据和事件
	     */
	    _this.menuProps = {
	      data: [],
	      onExpand: _util.noop,
	      onSelect: _util.noop,
	      onCheck: _util.noop,
	      onChange: _util.noop
	    };
	    /**
	     * 当前下拉菜单中的有效组件类型，Tree, List
	     */
	    _this.menuType = null;
	    _this.searchInputRef = 'search-input';
	    _this.initializeMenuProps(props);

	    /**
	     * 存储tree数据的类对象，用于数据搜索
	     */
	    _this.dataTree; // = new DataTree().import()
	    /**
	     * 用于阻止事件冒泡，参考react-overlay的做法
	     */
	    // 用了symbol 命名后，导致栈溢出.. 原因未知
	    _this._suppressRootId = '__click_rt_select_was_inside__';
	    _this._suppressRootCloseHandler = function (event) {
	      event.nativeEvent[_this._suppressRootId] = true;
	      event.stopPropagation();
	    };
	    return _this;
	  }

	  (0, _createClass3.default)(Select, [{
	    key: 'componentDidMount',
	    value: function componentDidMount() {}
	  }, {
	    key: 'componentWillUnmount',
	    value: function componentWillUnmount() {
	      this.unbindRootCloseHandlers();
	    }
	  }, {
	    key: 'componentWillReceiveProps',
	    value: function componentWillReceiveProps(nextProps) {
	      this.initializeMenuProps(nextProps);
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      var _props = this.props;
	      var className = _props.className;
	      var prefixCls = _props.prefixCls;
	      var children = _props.children;
	      var onClear = _props.onClear;
	      var otherProps = (0, _objectWithoutProperties3.default)(_props, ['className', 'prefixCls', 'children', 'onClear']);


	      return _react2.default.createElement(
	        'div',
	        (0, _extends3.default)({}, otherProps, { className: (0, _classnames2.default)(className, prefixCls) }),
	        _react2.default.createElement(
	          'div',
	          { className: prefixCls + '-head', onClick: this.toggleMenuVisible },
	          _react2.default.createElement(
	            'label',
	            { title: this.state.inputValue },
	            this.state.inputValue
	          ),
	          this.state.inputValue && onClear ? _react2.default.createElement(
	            'span',
	            { className: 'clear-value-icon', onClick: this.clearSelected.bind(this) },
	            '×'
	          ) : null,
	          _react2.default.createElement(
	            'div',
	            { className: 'dropdown-toggle' },
	            _react2.default.createElement('i', null)
	          )
	        ),
	        this.renderMenu()
	      );
	    }
	  }, {
	    key: 'renderMenu',
	    value: function renderMenu() {
	      var _this2 = this;

	      var _props2 = this.props;
	      var prefixCls = _props2.prefixCls;
	      var children = _props2.children;
	      var menuStyle = _props2.menuStyle;
	      var emptyDataText = _props2.emptyDataText;
	      var search = _props2.search;
	      var searchInputPlaceholder = _props2.searchInputPlaceholder;
	      var _state = this.state;
	      var menuVisible = _state.menuVisible;
	      var searchInputValue = _state.searchInputValue;

	      var style = (0, _extends3.default)({}, menuStyle || {}, { display: menuVisible ? 'block' : 'none' });

	      return _react2.default.createElement(
	        'div',
	        { style: style, className: prefixCls + '-menu', onClick: this._suppressRootCloseHandler },
	        _react2.default.Children.map(children, function (child) {
	          // 节点为Tree组件时，给它添加相应的属性与事件，以便Tree和Select关联起来
	          var elementType = _this2.isValidElement(child);
	          if (elementType) {

	            // 检查数据是否有更新
	            if (child.props !== _this2.menuProps) {
	              _this2.updateMenuProps(child, elementType);
	            }

	            // 这里获取最新数据
	            var _state2 = _this2.state;
	            var data = _state2.data;
	            var expanded = _state2.expanded;

	            var element = void 0;

	            if (!data || data.length <= 0) {
	              element = _react2.default.createElement(
	                'p',
	                { className: 'empty-data-text' },
	                emptyDataText
	              );
	            } else {
	              var props = {
	                data: data,
	                bordered: false,
	                expanded: expanded,
	                onExpand: _this2.onExpand,
	                onSelect: _this2.onSelect,
	                onCheck: _this2.onCheck,
	                onChange: _this2.onChange
	              };

	              element = _react2.default.cloneElement(child, props);
	            }

	            // 添加搜索框
	            if (search) {
	              element = _react2.default.createElement(
	                'div',
	                null,
	                _react2.default.createElement(
	                  'div',
	                  { className: 'search-input-wrapper' },
	                  _react2.default.createElement('input', {
	                    ref: _this2.searchInputRef,
	                    type: 'text',
	                    placeholder: searchInputPlaceholder,
	                    value: searchInputValue,
	                    onChange: _this2.handleSearchInputChange }),
	                  _react2.default.createElement('i', { className: 'icon-search' })
	                ),
	                element
	              );
	            }

	            return element;
	          }

	          return child;
	        })
	      );
	    }
	  }, {
	    key: 'initializeMenuProps',
	    value: function initializeMenuProps(props) {
	      var _this3 = this;

	      // TODO: 是否有必要遍历其所有子节点，找到这里需要接管的组件（Tree, List）？
	      _react2.default.Children.forEach(props.children, function (child) {
	        // 节点为Tree, List组件时，给它添加相应的属性与事件，以便Tree和Select关联起来
	        var elementType = _this3.isValidElement(child);
	        if (elementType) {
	          _this3.updateMenuProps(child, elementType);
	          return;
	        }
	      });
	    }
	  }, {
	    key: 'updateMenuProps',
	    value: function updateMenuProps(node, elementType) {
	      // 把要接管的组件props存储起来，方便后面使用
	      var _node$props = node.props;
	      var data = _node$props.data;
	      var expanded = _node$props.expanded;
	      var defaultExpanded = _node$props.defaultExpanded;


	      if (data !== this.menuProps.data) {
	        // 重置state
	        this.state.data = data;
	        this.state.expanded = (this.initial ? expanded || defaultExpanded : expanded) || [];
	        // this.state.inputValue = null
	        this.state.searchInputValue = null;

	        if (this.isTreeElement(elementType)) {
	          this.dataTree = new _dataTree2.default().import(data.slice());
	          // this.state.data = this.dataTree.export()
	        }
	      }

	      // 如果menuProps.data已有数据，把initial设为false
	      this.initial = !(this.initial && this.menuProps.data && this.menuProps.data.length > 0);
	      this.menuProps = node.props;
	      this.menuType = elementType;
	      this.updateInputValue();
	    }
	  }, {
	    key: 'updateInputValue',
	    value: function updateInputValue() {
	      var _this4 = this;

	      var _menuProps = this.menuProps;
	      var data = _menuProps.data;
	      var commbox = _menuProps.commbox;
	      var selected = _menuProps.selected;
	      var defaultSeleced = _menuProps.defaultSeleced;
	      var checked = _menuProps.checked;
	      var defaultChecked = _menuProps.defaultChecked;


	      var selectedValues = void 0,
	          selectedDatas = [];

	      if (commbox) {
	        selectedValues = (this.initial ? checked || defaultChecked : checked) || [];
	      } else {
	        selectedValues = (this.initial ? selected || defaultSeleced : selected) || [];
	      }

	      // 根据节点选中项设置inputValue
	      selectedValues.forEach(function (value) {
	        var node = _this4.dataTree.searchDFS(function (data) {
	          return data.id === value;
	        });
	        node && selectedDatas.push(node.data());
	      });

	      var inputValue = selectedDatas.map(function (o) {
	        return o.text;
	      }).join(', ');
	      this.initial ? this.state.inputValue = inputValue : this.setState({ inputValue: inputValue });
	    }

	    /**
	     * 判断是否有效的Tree, List组件，如果是，返回组件的类型，否则还回false
	     * 由于并不依懒于Tree, List组件，所以这里仅以它的displayName来判断
	     */

	  }, {
	    key: 'isValidElement',
	    value: function isValidElement(element) {
	      var elementType = element.type ? element.type.elementType : undefined;
	      return elementType && (this.isTreeElement(elementType) || this.isListElement(elementType)) ? elementType : false;
	    }
	  }, {
	    key: 'isTreeElement',
	    value: function isTreeElement(elementType) {
	      return (elementType || this.menuType) === _util.TREE_ELEMENT;
	    }
	  }, {
	    key: 'isListElement',
	    value: function isListElement(elementType) {
	      return (elementType || this.menuType) === _util.LIST_ELEMENT;
	    }
	  }, {
	    key: 'bindRootCloseHandlers',
	    value: function bindRootCloseHandlers() {
	      var doc = (0, _util.ownerDocument)(this);
	      this._onDocumentClickListener = (0, _util.addEventListener)(doc, 'click', this.handleDocumentClick);
	    }
	  }, {
	    key: 'unbindRootCloseHandlers',
	    value: function unbindRootCloseHandlers() {
	      if (this._onDocumentClickListener) {
	        this._onDocumentClickListener.remove();
	      }
	    }
	  }, {
	    key: 'handleDocumentClick',
	    value: function handleDocumentClick(e) {
	      // This is now the native event.
	      if (e[this._suppressRootId]) {
	        return;
	      }
	      this.toggleMenuVisible();
	    }
	  }, {
	    key: 'toggleMenuVisible',
	    value: function toggleMenuVisible() {
	      var _this5 = this;

	      this.setState({
	        menuVisible: !this.state.menuVisible
	      }, function () {
	        if (_this5.state.menuVisible) {
	          _this5.bindRootCloseHandlers();

	          // 让搜索框获得焦点
	          if (_this5.props.search) {
	            var input = _this5.refs[_this5.searchInputRef];
	            input && input.focus();
	          }
	        } else if (!_this5.state.menuVisible) {
	          _this5.unbindRootCloseHandlers();
	        }
	      });
	    }
	  }, {
	    key: 'onExpand',
	    value: function onExpand(expanded, node) {
	      var nodeValue = node.props.value;
	      // 这里维护Tree.props.expanded的值，因为在搜索时，会用到
	      this.setState({
	        expanded: expanded ? [].concat((0, _toConsumableArray3.default)(this.state.expanded), [nodeValue]) : this.state.expanded.filter(function (item) {
	          return item !== nodeValue;
	        })
	      });
	      this.menuProps.onExpand(expanded, node);
	    }
	  }, {
	    key: 'onSelect',
	    value: function onSelect(selected, value, data, node) {
	      return this.onEvent('select', selected, value, data, node);
	    }
	  }, {
	    key: 'onCheck',
	    value: function onCheck(checked, value, data, node) {
	      return this.onEvent('check', checked, value, data, node);
	    }
	  }, {
	    key: 'onEvent',
	    value: function onEvent(eventType, selected, value, data, node) {
	      var selectToClose = this.props.selectToClose;
	      var _menuProps2 = this.menuProps;
	      var multiple = _menuProps2.multiple;
	      var onSelect = _menuProps2.onSelect;
	      var onCheck = _menuProps2.onCheck;

	      var result = void 0;

	      switch (eventType) {
	        case 'select':
	          result = onSelect(selected, value, data, node);break;
	        case 'check':
	          result = onCheck(selected, value, data, node);break;
	      }

	      if (!multiple && selected && selectToClose && result !== false) {
	        this.toggleMenuVisible();
	      }

	      return result;
	    }
	  }, {
	    key: 'selectToClose',
	    value: function selectToClose() {
	      var selectToClose = this.props.selectToClose;
	      var multiple = this.menuProps.multiple;
	      // 单选时，如果选中了选项，关闭下拉菜单

	      if (!multiple && selected && selectToClose) {
	        this.toggleMenuVisible();
	      }
	    }
	  }, {
	    key: 'onChange',
	    value: function onChange(value, data, node) {
	      this.menuProps.onChange(value, data, node);
	    }
	  }, {
	    key: 'setInputValue',
	    value: function setInputValue(data, initial) {
	      var inputValue = void 0;
	      // 把数据更新到input
	      if (data) {
	        if (Array.isArray(data)) {
	          data.length > 0 && (inputValue = data.map(function (o) {
	            return o.text;
	          }).join(', '));
	        } else {
	          inputValue = data.text;
	        }
	      }
	      initial ? this.state.inputValue = inputValue : this.setState({ inputValue: inputValue });
	    }
	  }, {
	    key: 'clearSelected',
	    value: function clearSelected(e) {
	      e.stopPropagation();
	      this.props.onClear && this.props.onClear();
	    }
	  }, {
	    key: 'handleSearchInputChange',
	    value: function handleSearchInputChange() {
	      var searchInputValue = this.refs[this.searchInputRef].value;
	      var result = void 0;

	      // 使用输入法时，每次keyDown都会触发该onChange事件，但input的值实际上还没变更，这里判断一下
	      if (searchInputValue !== this.state.searchInputValue) {
	        // 过滤节点数据
	        if (this.isTreeElement()) {
	          result = this.filterTreeDatas(searchInputValue);
	        } else {
	          result = this.filterListDatas(searchInputValue);
	        }

	        this.setState((0, _extends3.default)({}, result || {}, {
	          searchInputValue: searchInputValue
	        }));
	      }
	    }
	  }, {
	    key: 'filterTreeDatas',
	    value: function filterTreeDatas(keyWord) {
	      var _this6 = this;

	      var data = this.menuProps.data;

	      var expanded = [];
	      if (!keyWord) {
	        return { data: data };
	      }
	      // 重置树节点数据
	      var tree = this.dataTree;
	      tree.import(data.slice());
	      // 使用深度优先搜索算法搜索树节点
	      tree.traverseDFS(function (node) {
	        // 如果存在多各根节点的情形
	        if (node._depth == 1 && node._childNodes.length > 1) {
	          node._childNodes.forEach(function (nodeItem) {
	            _this6.loopDFS_keyWord(nodeItem, expanded, keyWord);
	          });
	        } else {
	          _this6.loopDFS_keyWord(node, expanded, keyWord);
	        }
	      });

	      var afterFilter = this.filterExpanedTree(tree.export());
	      // 重置
	      this.dataTree.import(data.slice());

	      // 只搜索到一个节点时，不展开该节点
	      if (expanded.length === 1) return { data: afterFilter, expanded: [] };else if (expanded.length > 1) return { data: afterFilter, expanded: expanded };else return { data: null };
	    }
	  }, {
	    key: 'loopDFS_keyWord',
	    value: function loopDFS_keyWord(node, expanded, keyWord) {
	      var _this7 = this;

	      var nodeData = node.data();
	      if (nodeData.text.indexOf(keyWord) > -1) {
	        expanded.push(nodeData.id);
	        (0, _assign2.default)(nodeData, { expanded: true });
	        //获取它所有的祖先节点，把它的ID放到map中
	        node.getAncestry().forEach(function (item) {
	          var id = item.data().id;
	          item.data((0, _extends3.default)({}, item.data(), { expanded: true }));
	          if (_this7.contains(id, expanded) === false) {
	            expanded.push(id);
	          }
	        });
	      } else {
	        // 为避免上次记录被保存，没有展开的再次遍历，设置false
	        (0, _assign2.default)(nodeData, { expanded: false });
	      }
	    }

	    // 数组中是否包含  

	  }, {
	    key: 'contains',
	    value: function contains(id, arr) {
	      var bool = false;
	      arr.map(function (item) {
	        if (item == id) {
	          return bool = true;
	        }
	      });
	      return bool;
	    }

	    // 对过滤展开的树进行递归筛选

	  }, {
	    key: 'filterExpanedTree',
	    value: function filterExpanedTree(treeDatas) {
	      var _this8 = this;

	      var tree = [];
	      var loopTree = function loopTree(trees, store) {
	        Array.isArray(trees) && trees.map(function (item) {
	          if (item.expanded === true) {
	            var children = item.children;
	            var node = (0, _objectWithoutProperties3.default)(item, ['children']);

	            var childrens = _this8.childNodeHasExpaned(item.children) ? [] : item.children;
	            (0, _assign2.default)(node, { children: childrens });
	            store.push(node);
	            loopTree(item.children, node.children);
	          }
	        });
	      };
	      loopTree(treeDatas, tree);
	      return tree;
	    }
	  }, {
	    key: 'filterListDatas',
	    value: function filterListDatas(keyWord) {}
	    // TODO

	    // 判断其孩子中是否包含需要展开的节点。

	  }, {
	    key: 'childNodeHasExpaned',
	    value: function childNodeHasExpaned(children) {
	      // 假设没有
	      var bool = false;
	      Array.isArray(children) && children.forEach(function (item) {
	        if (item.expanded === true) {
	          return bool = true;
	        }
	      });
	      return bool;
	    }
	  }]);
	  return Select;
	}(_react2.default.Component);

	Select.propTypes = {
	  /**
	   * 下拉菜单的style
	   * @type {Object}
	   */
	  menuStyle: _react.PropTypes.object,
	  /**
	   * 数据为空时，显示的文本信息
	   * @type {String}
	   */
	  emptyDataText: _react.PropTypes.string,
	  /**
	   * 是否启用节点过滤功能
	   * @type {Boolean}
	   */
	  search: _react.PropTypes.bool,
	  /**
	   * 查询框的placeholder值
	   */
	  searchInputPlaceholder: _react.PropTypes.string,
	  /**
	   * 选中时，是否自动关闭下拉菜单（仅单选有效）
	   */
	  selectToClose: _react.PropTypes.bool,
	  /**
	   * onClear 
	   */
	  onClear: _react.PropTypes.func
	};

	Select.defaultProps = {
	  prefixCls: 'rt-select',
	  emptyDataText: '没有可显示的数据',
	  searchInputPlaceholder: '搜索',
	  selectToClose: true
	};

	exports.default = Select;

/***/ },
/* 101 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	exports.__esModule = true;

	var _from = __webpack_require__(102);

	var _from2 = _interopRequireDefault(_from);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = function (arr) {
	  if (Array.isArray(arr)) {
	    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
	      arr2[i] = arr[i];
	    }

	    return arr2;
	  } else {
	    return (0, _from2.default)(arr);
	  }
	};

/***/ },
/* 102 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(103), __esModule: true };

/***/ },
/* 103 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(56);
	__webpack_require__(104);
	module.exports = __webpack_require__(7).Array.from;

/***/ },
/* 104 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var ctx            = __webpack_require__(8)
	  , $export        = __webpack_require__(5)
	  , toObject       = __webpack_require__(38)
	  , call           = __webpack_require__(105)
	  , isArrayIter    = __webpack_require__(106)
	  , toLength       = __webpack_require__(29)
	  , createProperty = __webpack_require__(107)
	  , getIterFn      = __webpack_require__(108);

	$export($export.S + $export.F * !__webpack_require__(110)(function(iter){ Array.from(iter); }), 'Array', {
	  // 22.1.2.1 Array.from(arrayLike, mapfn = undefined, thisArg = undefined)
	  from: function from(arrayLike/*, mapfn = undefined, thisArg = undefined*/){
	    var O       = toObject(arrayLike)
	      , C       = typeof this == 'function' ? this : Array
	      , aLen    = arguments.length
	      , mapfn   = aLen > 1 ? arguments[1] : undefined
	      , mapping = mapfn !== undefined
	      , index   = 0
	      , iterFn  = getIterFn(O)
	      , length, result, step, iterator;
	    if(mapping)mapfn = ctx(mapfn, aLen > 2 ? arguments[2] : undefined, 2);
	    // if object isn't iterable or it's array with default iterator - use simple case
	    if(iterFn != undefined && !(C == Array && isArrayIter(iterFn))){
	      for(iterator = iterFn.call(O), result = new C; !(step = iterator.next()).done; index++){
	        createProperty(result, index, mapping ? call(iterator, mapfn, [step.value, index], true) : step.value);
	      }
	    } else {
	      length = toLength(O.length);
	      for(result = new C(length); length > index; index++){
	        createProperty(result, index, mapping ? mapfn(O[index], index) : O[index]);
	      }
	    }
	    result.length = index;
	    return result;
	  }
	});


/***/ },
/* 105 */
/***/ function(module, exports, __webpack_require__) {

	// call something on iterator step with safe closing on error
	var anObject = __webpack_require__(12);
	module.exports = function(iterator, fn, value, entries){
	  try {
	    return entries ? fn(anObject(value)[0], value[1]) : fn(value);
	  // 7.4.6 IteratorClose(iterator, completion)
	  } catch(e){
	    var ret = iterator['return'];
	    if(ret !== undefined)anObject(ret.call(iterator));
	    throw e;
	  }
	};

/***/ },
/* 106 */
/***/ function(module, exports, __webpack_require__) {

	// check on default Array iterator
	var Iterators  = __webpack_require__(61)
	  , ITERATOR   = __webpack_require__(67)('iterator')
	  , ArrayProto = Array.prototype;

	module.exports = function(it){
	  return it !== undefined && (Iterators.Array === it || ArrayProto[ITERATOR] === it);
	};

/***/ },
/* 107 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var $defineProperty = __webpack_require__(11)
	  , createDesc      = __webpack_require__(19);

	module.exports = function(object, index, value){
	  if(index in object)$defineProperty.f(object, index, createDesc(0, value));
	  else object[index] = value;
	};

/***/ },
/* 108 */
/***/ function(module, exports, __webpack_require__) {

	var classof   = __webpack_require__(109)
	  , ITERATOR  = __webpack_require__(67)('iterator')
	  , Iterators = __webpack_require__(61);
	module.exports = __webpack_require__(7).getIteratorMethod = function(it){
	  if(it != undefined)return it[ITERATOR]
	    || it['@@iterator']
	    || Iterators[classof(it)];
	};

/***/ },
/* 109 */
/***/ function(module, exports, __webpack_require__) {

	// getting tag from 19.1.3.6 Object.prototype.toString()
	var cof = __webpack_require__(26)
	  , TAG = __webpack_require__(67)('toStringTag')
	  // ES3 wrong here
	  , ARG = cof(function(){ return arguments; }()) == 'Arguments';

	// fallback for IE11 Script Access Denied error
	var tryGet = function(it, key){
	  try {
	    return it[key];
	  } catch(e){ /* empty */ }
	};

	module.exports = function(it){
	  var O, T, B;
	  return it === undefined ? 'Undefined' : it === null ? 'Null'
	    // @@toStringTag case
	    : typeof (T = tryGet(O = Object(it), TAG)) == 'string' ? T
	    // builtinTag case
	    : ARG ? cof(O)
	    // ES3 arguments fallback
	    : (B = cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
	};

/***/ },
/* 110 */
/***/ function(module, exports, __webpack_require__) {

	var ITERATOR     = __webpack_require__(67)('iterator')
	  , SAFE_CLOSING = false;

	try {
	  var riter = [7][ITERATOR]();
	  riter['return'] = function(){ SAFE_CLOSING = true; };
	  Array.from(riter, function(){ throw 2; });
	} catch(e){ /* empty */ }

	module.exports = function(exec, skipClosing){
	  if(!skipClosing && !SAFE_CLOSING)return false;
	  var safe = false;
	  try {
	    var arr  = [7]
	      , iter = arr[ITERATOR]();
	    iter.next = function(){ return {done: safe = true}; };
	    arr[ITERATOR] = function(){ return iter; };
	    exec(arr);
	  } catch(e){ /* empty */ }
	  return safe;
	};

/***/ },
/* 111 */
/***/ function(module, exports) {

	module.exports = undefined;

/***/ }
/******/ ]);